    subroutine calc_apex_params_2d_2( &
                  IN , IS, &
                  gr, gcol, glon, &
                  RE_apex , q_coordinate , BLOn, &
                  bcol,vmp_tube, &
                  vmp_apex,vmp_south_pole, &
                  B_magnitude_on_tubes_3D, &
                  Apex_D1, &
                  Apex_D2, &
                  Apex_D3, &
                  Apex_E1, &
                  Apex_E2, &
                  Apex_E3, &
                  Apex_BE3, &
                  DATE)

    IMPLICIT NONE

    INTEGER :: NPTS , NMP , NLP
    INCLUDE 'npts.h'
    INTEGER :: IN(NMP,NLP) , IS(NMP,NLP)
    INTEGER :: i , j
    INTEGER :: mp , lp
    REAL(kind=8) R0
    REAL(kind=8) PI
    REAL(kind=8) DTR
    REAL(kind=8) RTD
    REAL(kind=8) Date
    REAL(kind=8) RE_apex(NMP,NLP)
    REAL(kind=8) Apex_D1(3,NPTS,NMP,NLP)
    REAL(kind=8) Apex_D2(3,NPTS,NMP,NLP)
    REAL(kind=8) Apex_D3(3,NPTS,NMP,NLP)
    REAL(kind=8) Apex_E1(3,NPTS,NMP,NLP)
    REAL(kind=8) Apex_E2(3,NPTS,NMP,NLP)
    REAL(kind=8) Apex_E3(3,NPTS,NMP,NLP)
    REAL(kind=8) Apex_BE3(NPTS,NMP,NLP)
    REAL(kind=8) Apex_grdlbm2(3,NPTS,NMP,NLP)
    REAL(kind=8) ETA_APEX_3D(NPTS,NMP,NLP)
    REAL(kind=8) e3e3
    REAL(kind=8) Apex_BHAT(3,npts,nmp,nlp)
    REAL(kind=8) Apex_D(npts,nmp,nlp)
    REAL(kind=8) Apex_d1d1(npts,nmp,nlp)
    REAL(kind=8) Apex_d1d2(npts,nmp,nlp)
    REAL(kind=8) Apex_d2d2(npts,nmp,nlp)
    REAL(kind=8) Apex_BMAG(npts,nmp,nlp)
    REAL(kind=8) vmp_tube(npts,nmp,nlp)
    REAL(kind=8) vmp_apex(nmp,nlp)
    REAL(kind=8) vmp_south_pole
    REAL(kind=8) B_magnitude_on_tubes_3D(npts,nmp,nlp)
    REAL(kind=8) gr(NPTS,nmp,nlp)
    REAL(kind=8) gcol(NPTS,nmp,nlp)
    REAL(kind=8) glon(NPTS,nmp,nlp)
    REAL(kind=8) bcol(NPTS,NMP,NLP)
    REAL(kind=8) BLOn(NMP,NLP)
    REAL(kind=8) q_coordinate(NPTS,NMP,NLP)
    INTEGER :: i_count
    INTEGER :: IN_2d(NLP) , IS_2d(NLP)
    INTEGER :: IN_2d_3d(NMP,NLP) , IS_2d_3d(NMP,NLP)
    integer npts2
!   parameter (npts2=12279)
    parameter (npts2=13813)
    real(kind=8) gr_2d(npts2,nmp)
    real(kind=8) gcol_2d(npts2,nmp)
    real(kind=8) glon_2d(npts2,nmp)
    real(kind=8) q_coordinate_2d(npts2,nmp)
    real(kind=8) bcol_2d(npts2,nmp)
    real(kind=8) vmp_tube_2d(npts2,nmp)
    real(kind=8) B_magnitude_on_tubes_3D_2d(npts2,nmp)
    real(kind=8) Apex_D1_2d(3,npts2,nmp)
    real(kind=8) Apex_D2_2d(3,npts2,nmp)
    real(kind=8) Apex_D3_2d(3,npts2,nmp)
    real(kind=8) Apex_E1_2d(3,npts2,nmp)
    real(kind=8) Apex_E2_2d(3,npts2,nmp)
    real(kind=8) Apex_E3_2d(3,npts2,nmp)
    real(kind=8) Apex_BE3_2d(npts2,nmp)
    real(kind=8) Apex_grdlbm2_2d(3,npts2,nmp)
    real(kind=8) Eta_Apex_3d_2d(npts2,nmp)
    real(kind=8) apex_D_2d(npts2,nmp)
    real(kind=8) apex_BHAT_2d(3,npts2,nmp)
    real(kind=8) apex_d1d1_2d(npts2,nmp)
    real(kind=8) apex_d1d2_2d(npts2,nmp)
    real(kind=8) apex_d2d2_2d(npts2,nmp)
    real(kind=8) apex_BMAG_2d(npts2,nmp)

    integer midpoint(nlp)

    PARAMETER (PI=3.141592654,DTR=PI/180.0,RTD=180.0/PI,R0=6.370E06)

        call cofrm2(date)
        call get_apex2(gr, gcol, glon,npts,nmp,nlp, &
        Apex_grdlbm2,in,is)


!g
!g  For our new Apex code we calculate magnetic field parameters as 3D
!g  variables just once - at the start....
!g
    do mp=1,nmp
        do lp=1,nlp
            do i=in(mp,lp),is(mp,lp)
            !g
            !g Be3 as read in above is in nT - we need T therefore need to multiply by 1.e-09 here.
            !g This also feeds through to BMAG below (which is therfore automatically correctly in Tesla).....
            !g
                Apex_Be3(i,mp,lp) = Apex_Be3(i,mp,lp) * 1.e-09
            !g
            !g Added a minus sign here to ETA - otherwise DS comes out negative.....
            !g
                Eta_Apex_3d(i,mp,lp) = 0.0 - ( B_magnitude_on_tubes_3D(i,mp,lp) &
                / vmp_south_pole )
            enddo
        enddo
    enddo
!g
!g  We also need Bmag, D, bHat and Dhat as 3D variables.....
!g
! get D
    lp_loop1: do lp = 1,nlp
    mp_loop1: do mp = 1,nmp
    ipts_loop1: do i = in(mp,lp),is(mp,lp)
    e3e3=dot_product( Apex_E3(1:3,i,mp,lp), Apex_E3(1:3,i,mp,lp) )
    apex_D(i,mp,lp)=SQRT( e3e3 ) !(3.13) D * D = e3 * e3
enddo  ipts_loop1
enddo  mp_loop1
enddo  lp_loop1

! get BHAT
    lp_loop2: do lp = 1,nlp
    mp_loop2: do mp = 1,nmp
    do J=1,3
        apex_BHAT(J,in(mp,lp):is(mp,lp),mp,lp)=apex_D3(J,in(mp,lp):is(mp,lp),mp,lp)*apex_D(in(mp,lp):is(mp,lp),mp,lp)
    enddo
enddo mp_loop2
enddo lp_loop2

! get d1d2 etc
    lp_loop3: do lp = 1,nlp
    mp_loop3: do mp = 1,nmp
    ipts_loop3: do i = in(mp,lp),is(mp,lp)
    apex_d1d1(i,mp,lp)=dot_product(Apex_d1(1:3,i,mp,lp),Apex_d1(1:3,i,mp,lp))
    apex_d1d2(i,mp,lp)=dot_product(Apex_d1(1:3,i,mp,lp),Apex_d2(1:3,i,mp,lp))
    apex_d2d2(i,mp,lp)=dot_product(Apex_d2(1:3,i,mp,lp),Apex_d2(1:3,i,mp,lp))
enddo  ipts_loop3 !: do i = in(mp,lp),is(mp,lp)
enddo  mp_loop3   !: do mp = 1,nmp
enddo  lp_loop3   !: do lp = 1,nlp

! get BMAG
    lp_loop4: do lp = 1,nlp
    mp_loop4: do mp = 1,nmp
    apex_BMAG(in(mp,lp):is(mp,lp),mp,lp) = Apex_BE3(in(mp,lp):is(mp,lp),mp,lp)*apex_D(in(mp,lp):is(mp,lp),mp,lp)    !(4.13)
enddo  mp_loop4  !: do mp = 1,nmp
enddo  lp_loop4  !: do lp = 1,nlp

!   open(114,file='plasma_tube_apex_coords_2.2005.format_latest',form='formatted',status='unknown')

    i_count = 0
    do lp = 1 , nlp
    in_2d(lp) = i_count + 1
    is_2d(lp) = in_2d(lp) + is(1,lp) - in(1,lp)
    i_count = is_2d(lp)
    enddo
    
    do lp = 1 , nlp
      write(6,*) 'points ',lp,in(1,lp),is(1,lp),in_2d(lp),is_2d(lp)
    enddo

    do mp = 1 , nmp
    do lp = 1 , nlp
      
    gr_2d(in_2d(lp):is_2d(lp),mp) = gr(in(mp,lp):is(mp,lp),mp,lp)
    gcol_2d(in_2d(lp):is_2d(lp),mp) = gcol(in(mp,lp):is(mp,lp),mp,lp)
    glon_2d(in_2d(lp):is_2d(lp),mp) = glon(in(mp,lp):is(mp,lp),mp,lp)
    q_coordinate_2d(in_2d(lp):is_2d(lp),mp) = q_coordinate(in(mp,lp):is(mp,lp),mp,lp)
    bcol_2d(in_2d(lp):is_2d(lp),mp) = bcol(in(mp,lp):is(mp,lp),mp,lp)
    vmp_tube_2d(in_2d(lp):is_2d(lp),mp) = vmp_tube(in(mp,lp):is(mp,lp),mp,lp)
    B_magnitude_on_tubes_3D_2d(in_2d(lp):is_2d(lp),mp) = B_magnitude_on_tubes_3D(in(mp,lp):is(mp,lp),mp,lp)
    Apex_BE3_2d(in_2d(lp):is_2d(lp),mp) = Apex_BE3(in(mp,lp):is(mp,lp),mp,lp)
    Eta_Apex_3d_2d(in_2d(lp):is_2d(lp),mp) = Eta_Apex_3d(in(mp,lp):is(mp,lp),mp,lp)
    apex_D_2d(in_2d(lp):is_2d(lp),mp) = apex_D(in(mp,lp):is(mp,lp),mp,lp)
    apex_d1d1_2d(in_2d(lp):is_2d(lp),mp) = apex_d1d1(in(mp,lp):is(mp,lp),mp,lp)
    apex_d2d2_2d(in_2d(lp):is_2d(lp),mp) = apex_d2d2(in(mp,lp):is(mp,lp),mp,lp)
    apex_BMAG_2d(in_2d(lp):is_2d(lp),mp) = apex_BMAG(in(mp,lp):is(mp,lp),mp,lp)

    do j = 1 , 3
    Apex_D1_2d(j,in_2d(lp):is_2d(lp),mp) = Apex_D1(j,in(mp,lp):is(mp,lp),mp,lp)
    Apex_D2_2d(j,in_2d(lp):is_2d(lp),mp) = Apex_D2(j,in(mp,lp):is(mp,lp),mp,lp)
    Apex_D3_2d(j,in_2d(lp):is_2d(lp),mp) = Apex_D3(j,in(mp,lp):is(mp,lp),mp,lp)
    Apex_E1_2d(j,in_2d(lp):is_2d(lp),mp) = Apex_E1(j,in(mp,lp):is(mp,lp),mp,lp)
    Apex_E2_2d(j,in_2d(lp):is_2d(lp),mp) = Apex_E2(j,in(mp,lp):is(mp,lp),mp,lp)
    Apex_E3_2d(j,in_2d(lp):is_2d(lp),mp) = Apex_E3(j,in(mp,lp):is(mp,lp),mp,lp)
    Apex_grdlbm2_2d(j,in_2d(lp):is_2d(lp),mp) = Apex_grdlbm2(j,in(mp,lp):is(mp,lp),mp,lp)
    apex_BHAT_2d(j,in_2d(lp):is_2d(lp),mp) = apex_BHAT(j,in(mp,lp):is(mp,lp),mp,lp)
    enddo

    enddo
    enddo

    do mp = 1 , nmp
    do lp = 1 , nlp
       in_2d_3d(mp,lp) = in_2d(lp)
       is_2d_3d(mp,lp) = is_2d(lp)
    enddo
    enddo
        print *, "Begin writing file..."
        write(114,*) IN_2d_3d , IS_2d_3d
        write(114,*) gr_2d, gcol_2d, glon_2d
        write(114,*) RE_apex , q_coordinate_2d , BLOn
!        write(114,*) bcol_2d,vmp_tube_2d
        write(114,*) bcol_2d
!        write(114,*) vmp_apex,vmp_south_pole
!        write(114,*) B_magnitude_on_tubes_3D_2d
        write(114,*) Apex_D1_2d
        write(114,*) Apex_D2_2d
!        write(114,*) Apex_D3_2d
        write(114,*) Apex_E1_2d
        write(114,*) Apex_E2_2d
!        write(114,*) Apex_E3_2d
        write(114,*) Apex_BE3_2d
        write(114,*) Apex_grdlbm2_2d
        write(114,*) Eta_Apex_3d_2d
!        write(114,*) e3e3
        write(114,*) apex_D_2d
        write(114,*) apex_BHAT_2d
        write(114,*) apex_d1d1_2d
        write(114,*) apex_d1d2_2d
        write(114,*) apex_d2d2_2d
        write(114,*) apex_BMAG_2d

        print *, "end writing..."
       
       open(unit=1114,file='GIP_latlonh.dat',status='unknown')
       do mp=1,nmp
       do lp=1,nlp
         do i=in(mp,lp),is(mp,lp)
           write(1114,111) mp,lp,i,(gr_2d(i,mp)-R0)/1000.,glon_2d(i,mp)/DTR,90.-gcol_2d(i,mp)/DTR
 111       format(I2,1X,I2,1X,I5,1X,F13.7,1X,2(F13.7,1X))
         enddo
       enddo
       end do
       close(1114)

       do lp = 1 , nlp
         midpoint(lp) = (in_2d_3d(1,lp) + is_2d_3d(1,lp))/2
       enddo
       print *, "calling newinterp_high_res_TEC"
       call newinterp_high_res_TEC(IN_2d_3d,IS_2d_3d,midpoint,gr_2d,gcol_2d,glon_2d)

!   stop
    end subroutine calc_apex_params_2d_2


    subroutine get_apex2(gr, gcol, glon,npts,nmp,nlp, &
    apex_grdlbm2,in, is)

! Reference:  Richmond, A. D., Ionospheric Electrodynamics Using
! Magnetic Apex Coordinates, J. Geomag. Geoelectr., 47, 191-212, 1995.

! INPUTS:
! GLAT = Geographic (geodetic) latitude, degrees, must be within
! the grid domain (GPLAT(1) <= GLAT <= GPLAT(NLAT)).
! GLON = Geographic (geodetic) longitude, degrees, must be within
! one revolution of the grid domain:
! GPLON(1) <= GLON-360.,GLON, or GLON+360. <= GPLON(NLON))
! ALT  = Altitude, km
! WK   = same as entry APXMKA
! RETURNS:
! BMAG   = magnitude of magnetic field, in nT
! BE3    = B_e3 of reference above (= Bmag/D), in nT
! D1,D2,D3,E1,E2,E3 = components (east, north, up) of base vectors
! described in reference above
! IST    = Return status:  okay (0); or failure (1).

! Dimensions of non-scalar arguments to APXMALL:
! GPLAT(NLAT),GPLON(NLON),GPALT(NALT),WK(LWK),
! B(3),BHAT(3),D1(3),D2(3),D3(3), E1(3),E2(3),E3(3), F1(2),F2(2)

    implicit none

    integer, intent(in) :: npts,nmp,nlp,in(nmp,nlp),is(nmp,nlp)
    real(kind = 8), intent(in) :: &
    gr(npts,nmp,nlp) ,    & ! Earth radii[m]
    gcol(npts,nmp,nlp) ,  & ! geog. colatitude [rad]
    glon(npts,nmp,nlp)    ! geog. longitude [rad]
    real(kind = 8), intent(out) :: apex_grdlbm2(3,npts,nmp,nlp)
    REAL(kind=8) PI
    REAL(kind=8) DTR
    REAL(kind=8) RTD
    PARAMETER (PI=3.141592654,DTR=PI/180.0,RTD=180.0/PI)

! local:
    integer:: ipts,mp,lp
    real(kind = 8) :: glon_deg,glat_deg,z_km
! m
    real(kind = 8) :: x,y,z, &
    bnrth,beast,bdown,bpx,bmx,bpy,bmy,bpz,bmz, &
    re_plasma2,amount
    real(kind = 8) :: dlbm2dx,dlbm2dy,dlbm2dz, &
    coslat,sinlat,coslon,sinlon


    bnrth = 0.
    beast = 0.
    bdown = 0.
    amount = 10.
    re_plasma2 = 6360.

    do mp = 1,nmp     ! loop over # of flux tubes in longitude
        do lp = 1,nlp  ! loop over # of flux tubes in latitude
            do ipts = in(mp,lp),is(mp,lp)    ! loop over points along flux tube
                glat_deg = 90. - gcol(ipts,mp,lp)*rtd  ! geo.colat[rad] -> geo.lat[deg]
                glon_deg = glon(ipts,mp,lp)*rtd      ! geo.lon[rad] -> geo.lon[deg]
                z_km = gr(ipts,mp,lp)*1e-3  - re_plasma2      ! earth radii[m] -> altitude [km]
            
            !C Calculate geocentric cartesian coordinates x,y,z (in km)
                call GD2CART2(GLAT_deg,GLON_deg,z_km,X,Y,Z)
            !C Calculate gradient of ALOG(B0**(-2)) [= -2*ALOG(B0)] in Cartesian
            !C   coordinates, in units of m^{-1}
            !g
            !g
            !g
                call FELDG2 (2,(X+amount)/re_plasma2,Y/re_plasma2,Z/re_plasma2,BNRTH,BEAST,BDOWN,BPX)
                call FELDG2 (2,(X-amount)/re_plasma2,Y/re_plasma2,Z/re_plasma2,BNRTH,BEAST,BDOWN,BMX)
                call FELDG2 (2,X/re_plasma2,(Y+amount)/re_plasma2,Z/re_plasma2,BNRTH,BEAST,BDOWN,BPY)
                call FELDG2 (2,X/re_plasma2,(Y-amount)/re_plasma2,Z/re_plasma2,BNRTH,BEAST,BDOWN,BMY)
                call FELDG2 (2,X/re_plasma2,Y/re_plasma2,(Z+amount)/re_plasma2,BNRTH,BEAST,BDOWN,BPZ)
                call FELDG2 (2,X/re_plasma2,Y/re_plasma2,(Z-amount)/re_plasma2,BNRTH,BEAST,BDOWN,BMZ)
                ! Converted these logs to use LOG instead of ALOG. mjh
                dlbm2dx = (log(BMX) - log(BPX))/1.E4
                dlbm2dy = (log(BMY) - log(BPY))/1.E4
                dlbm2dz = (log(BMZ) - log(BPZ))/1.E4
            !C Rotate gradient to local (east,north,up) coordinates
            !C (1=east, 2=north, 3=up)
                coslat = cos(glat_deg*DTR)
                sinlat = sin(glat_deg*DTR)
                coslon = cos(glon_deg*DTR)
                sinlon = sin(glon_deg*DTR)
                apex_grdlbm2(1,ipts,mp,lp) = -dlbm2dx*sinlon + dlbm2dy*coslon
                apex_grdlbm2(2,ipts,mp,lp) = -(dlbm2dx*coslon + dlbm2dy*sinlon)*sinlat+dlbm2dz*coslat
                apex_grdlbm2(3,ipts,mp,lp) = (dlbm2dx*coslon + dlbm2dy*sinlon)*coslat+dlbm2dz*sinlat
            ! g
            enddo! loop over points along flux tube
        enddo  ! loop over # of flux tubes in latitude
    enddo	! loop over # of flux tubes in longitude

    return
    end subroutine get_apex2






    SUBROUTINE newinterp_high_res_TEC(IN,IS,midpoint,gr,gcol,glon)

    IMPLICIT NONE
    integer npts, nmp, nlp 
    include 'npts.h'
    REAL(KIND=8) :: DTR
    REAL(KIND=8) :: factor
    REAL(KIND=8) :: gcol
    REAL(KIND=8) :: geol1
    REAL(KIND=8) :: geol2
    REAL(KIND=8) :: &
    geolat , glon , gr , grin , height , &
    phngd , plat , plon
    REAL(KIND=8) :: R0 , thngd
    REAL(KIND=8) :: x1 , xn , y1 , yn , z1 , zn , PI
    REAL(KIND=8) :: &
    facc , facfac , dd,hvec
    INTEGER :: i , ic , ifailed , iheight , &
    ihem , ilon , IN , in1 , in2 , &
    IS, nheights
    INTEGER :: l , lp , m , mp ,  midpoint(nlp) , &
    inearst , i1 , i2 , i3 , i4 , ii1 , ii2 , ii3 , &
    ii4
    REAL(KIND=8) :: maxlat , minlat 
    REAL(KIND=8) :: original_distance, &
    sorted_distance
    INTEGER :: MHIgh(90) , MLOw(90) , max_ic, minny1(1), &
    minny(3)
    PARAMETER (PI=3.141592654,DTR=PI/180.0,R0=6.370E06)
    PARAMETER (nheights = 31)
    allocatable :: original_distance(:),sorted_distance(:)

    integer npts2
!   parameter (npts2=12279)
    parameter (npts2=13813)
    parameter (max_ic = 2*nmp*nlp)
    DIMENSION gr(NPTS2,NMP) , gcol(NPTS2,NMP) , &
    glon(NPTS2,NMP) , &
    grin(NPTS2) , IN(NMP,NLP) , IS(NMP,NLP)
    DIMENSION plat(max_ic) , plon(max_ic) , &
    facc(max_ic) ,  &
    i1(max_ic), i2(max_ic), i3(max_ic) , i4(max_ic) , &
    ii1(3,nheights,91,90), ii2(3,nheights,91,90), &
    ii3(3,nheights,91,90) , ii4(3,nheights,91,90) , &
    facfac(3,nheights,91,90) , &
    dd(3,nheights,91,90),hvec(nheights)
    REAL(KIND=8) :: glon1 , glon2
! 31 heights (original?)
     DATA hvec/90.,95.,100.,105.,110.,115.,120.,125., &
         150.,175.,200.,225.,250.,275.,300.,325.,350.,375.,400., &
         450.,500.,550.,600.,700.,800.,900.,1000., &
         2000.,4000.,6370.,9000./

!g

!  calculate mhigh and mlow
   height = float(182)*5000.+90000.+R0
   print *, height
   ic = 0
   DO 650 mp = 1 , NMP
       DO 640 lp = 1 , NLP
           DO 610 i = IN(mp,lp) , IS(mp,lp)
               grin(i) = gr(i,mp)
           610 ENDDO
           DO 620 ihem = 1 , 2
               IF ( ihem == 1 ) THEN
                   call FASTNEARHTPLA(grin,height,in(mp,lp),midpoint(lp),in1,in2, &
                   inearst,ifailed)
               ELSE
                   call FASTNEARHTPLA(grin,height,is(mp,lp),midpoint(lp),in1,in2, &
                   inearst,ifailed)
               ENDIF

               IF ( ifailed == 0 ) THEN
                   ic = ic + 1
               !g  interpolation factor for each point....
                   factor = (height-grin(in1))/(grin(in2)-grin(in1))
                   facc(ic)=factor
               !g  position of this point in latitude and longitude....
                   plat(ic) = (((gcol(in2,mp)-gcol(in1,mp))* &
                   factor)+gcol(in1,mp))/DTR

                   glon2 = glon(in2,mp)
                   glon1 = glon(in1,mp)
                   if((glon2-glon1)/dtr > 10.) glon1 = glon1 + (360.*dtr)
                   if((glon2-glon1)/dtr < -10.) glon2 = glon2 + (360.*dtr)

                   plon(ic) = (((glon2 - glon1) * factor)+glon1)/DTR

                   IF ( plon(ic) >= 360. ) plon(ic) = plon(ic) - 360.
                   IF ( plon(ic) < 0. ) plon(ic) = plon(ic) + 360.

               !g  relevent parameters at the point.....
               !g
               !g keep the flux-tube indexes for each 'ic' point in 4 arrays ......
               !g
               !    i1(ic)=mp
               !    i2(ic)=lp
               !    i3(ic)=in2
              !    i4(ic)=in1
               ENDIF
           620 ENDDO
       640 ENDDO
   650 ENDDO
       DO 680 ilon = 1 , 90
           geol2 = FLOAT(ilon)*4.
           geol1 = FLOAT(ilon-2)*4.
           minlat = 90.
           maxlat = -90.
           DO 660 i = 1 , ic
               IF ( ilon == 1 ) THEN
                   IF ( plon(i) < 4. .OR. plon(i) > 356. ) THEN
                       geolat = 90. - plat(i)
                       IF ( geolat > maxlat ) maxlat = geolat
                       IF ( geolat < minlat ) minlat = geolat
                   ENDIF
               ELSEIF ( plon(i) <= geol2 .AND. plon(i) >= geol1 ) &
                   THEN
                   geolat = 90. - plat(i)
                   IF ( geolat > maxlat ) maxlat = geolat
                   IF ( geolat < minlat ) minlat = geolat
               ENDIF
       660 ENDDO
           MHIgh(ilon) = INT(maxlat/2.) + 45
           MLOw(ilon) = INT(minlat/2.) + 47
           write(6,5760) ilon,maxlat,mhigh(ilon),minlat,mlow(ilon)
          5760 format('mhigh mlow ',i4,f5.1,i4,f6.1,i4)
   680 ENDDO

!  end calculating mhigh and mlow

!   heights should be defined based on the fixed heights in GIP (nmp, I think)    
    DO 300 iheight = nheights,1,-1
      height = hvec(iheight)*1000. + R0 !convert to m

!       height = FLOAT(iheight-1)*5000. + 90000. + R0
!    DO 300 iheight = 183 , 1 , -1
        write(6,*) iheight,height
    !g
    !g Loop over all the flux tubes......
    !g
        ic = 0
        DO 150 mp = 1 , NMP
            DO 140 lp = 1 , NLP
                DO 110 i = IN(mp,lp) , IS(mp,lp)
                    grin(i) = gr(i,mp)
                110 ENDDO
                DO 120 ihem = 1 , 2
                    IF ( ihem == 1 ) THEN
                        call FASTNEARHTPLA(grin,height,in(mp,lp),midpoint(lp),in1,in2, &
                        inearst,ifailed)
                    ELSE
                        call FASTNEARHTPLA(grin,height,is(mp,lp),midpoint(lp),in1,in2, &
                        inearst,ifailed)
                    ENDIF

                    IF ( ifailed == 0 ) THEN
                        ic = ic + 1
                    !g  interpolation factor for each point....
                        factor = (height-grin(in1))/(grin(in2)-grin(in1))
                        facc(ic)=factor
                    !g  position of this point in latitude and longitude....
                        plat(ic) = (((gcol(in2,mp)-gcol(in1,mp))* &
                        factor)+gcol(in1,mp))/DTR

                        glon2 = glon(in2,mp)
                        glon1 = glon(in1,mp)

                        if((glon2-glon1)/dtr > 10.) glon1 = glon1 + (360.*dtr)
                        if((glon2-glon1)/dtr < -10.) glon2 = glon2 + (360.*dtr)

                        plon(ic) = (((glon2 - glon1) * factor)+glon1)/DTR

                        IF ( plon(ic) >= 360. ) plon(ic) = plon(ic) - 360.
                        IF ( plon(ic) < 0. ) plon(ic) = plon(ic) + 360.

                    !g  relevent parameters at the point.....
                    !g
                    !g keep the flux-tube indexes for each 'ic' point in 4 arrays ......
                    !g
                        i1(ic)=mp
                        i2(ic)=lp
                        i3(ic)=in2
                        i4(ic)=in1
                    ENDIF
                120 ENDDO
            140 ENDDO
        150 ENDDO
    !g
    !g  Find out the max and min latitudes covered at each geo
    !g  longitude by points at 1000 km....
    !g
!        IF ( iheight == 183 ) THEN
!            DO 180 ilon = 1 , 90
!                geol2 = FLOAT(ilon)*4.
!                geol1 = FLOAT(ilon-2)*4.
!                minlat = 90.
!                maxlat = -90.
!                DO 160 i = 1 , ic
!                    IF ( ilon == 1 ) THEN
!                        IF ( plon(i) < 4. .OR. plon(i) > 356. ) THEN
!                            geolat = 90. - plat(i)
!                            IF ( geolat > maxlat ) maxlat = geolat
!                            IF ( geolat < minlat ) minlat = geolat
!                        ENDIF
!                    ELSEIF ( plon(i) <= geol2 .AND. plon(i) >= geol1 ) &
!                        THEN
!                        geolat = 90. - plat(i)
!                        IF ( geolat > maxlat ) maxlat = geolat
!                        IF ( geolat < minlat ) minlat = geolat
!                    ENDIF
!                160 ENDDO
!                MHIgh(ilon) = INT(maxlat/2.) + 45
!                MLOw(ilon) = INT(minlat/2.) + 47
!                write(6,5760) ilon,maxlat,mhigh(ilon),minlat,mlow(ilon)
!                5760 format('mhigh mlow ',i4,f5.1,i4,f6.1,i4)
!            180 ENDDO
!        ENDIF
!        print *, iheight,ic
    !g
    !g  Now interpolate all the values at a given height
    !g   onto the Geo grid
        DO 250 l = 1 , 90
            phngd = FLOAT(l-1)*4.
            DO 220 m = MLOw(l) , MHIgh(l)
                thngd = 180. - (2.*FLOAT(m-1))
                xn = height*SIN(thngd*DTR)*COS(phngd*DTR)
                yn = height*SIN(thngd*DTR)*SIN(phngd*DTR)
                zn = height*COS(thngd*DTR)
            !g
            !g  loop over all points
            !g
                if(allocated(original_distance)) deallocate(original_distance)
                if(allocated(sorted_distance)) deallocate(sorted_distance)
                allocate (original_distance(ic),sorted_distance(ic))
                DO 200 i = 1 , ic
                    x1 = height*SIN((plat(i))*DTR)*COS((plon(i))*DTR)
                    y1 = height*SIN((plat(i))*DTR)*SIN((plon(i))*DTR)
                    z1 = height*COS((plat(i))*DTR)
                !g Cartesian distance to neutral point....
                    original_distance(i) = SQRT((x1-xn)*(x1-xn)+(y1-yn)*(y1-yn)+(z1-zn) &
                    *(z1-zn))
                    sorted_distance(i) = original_distance(i)
                200 ENDDO
            !g
                minny1 = minloc(sorted_distance)
                minny(1) = minny1(1)
                sorted_distance(minny(1)) = 1.d50
                minny1 = minloc(sorted_distance)
                minny(2) = minny1(1)
                sorted_distance(minny(2)) = 1.d50
                minny1 = minloc(sorted_distance)
                minny(3) = minny1(1)
                sorted_distance(minny(3)) = 1.d50
            !g
                do i=1,3
                !g
                !g  The 3 closest points are defined by 4 integers and a factor (mp,lp,in2,in1,facfac)......
                !g
                    ii1(i,iheight,m,l)=i1(minny(i))
                    ii2(i,iheight,m,l)=i2(minny(i))
                    ii3(i,iheight,m,l)=i3(minny(i))
                    ii4(i,iheight,m,l)=i4(minny(i))
                    facfac(i,iheight,m,l)=facc(minny(i))
                    dd(i,iheight,m,l)=original_distance(minny(i))
                enddo

            !g lat,lon loop.....
            220 ENDDO
        250 ENDDO
    !g  height loop....
    300 ENDDO
!g
    print *, 'done with height loop'
    write(114,*) facfac
    write(114,*) dd
    write(114,*) ii1
    write(114,*) ii2
    write(114,*) ii3
    write(114,*) ii4
    write(114,*) mlow
    write(114,*) mhigh
    close(114)
!g      
    RETURN









    end SUBROUTINE newinterp_high_res_TEC

    SUBROUTINE FASTNEARHTPLA(ARR,VALue,M_IN,N_IN,M,N,nearst,IFAiled)

! this routine finds which two elements of ARR
! surround Value.  Arr is a monotonically increasing array
! The start and end points for the search are M_IN and N_IN.
! The exit points surrounding Value are N and M
    IMPLICIT NONE
    integer npts2
!   parameter (npts2=12279)
    parameter (npts2=13813)
    REAL(kind=8) :: ARR , VALue , dist1 , dist2
    INTEGER :: IFAiled , M , N ,  &
    M_IN , N_IN , n1 , nearst
    DIMENSION ARR(NPTS2)

    N=N_IN
    M=M_IN
    IFAiled = 0
    if((value <= arr(n) .AND. value >= arr(m)) .OR. &
    (value >= arr(n) .AND. value <= arr(m))) then
        234 n1 =(n - m)/2 + m
        IF ( ARR(n1) > VALue ) then
            n=n1
        else
            m=n1
        ENDIF
        if(abs(n-m) > 1) goto 234
        dist1=abs(arr(n)-value)
        dist2=abs(arr(m)-value)
        if(dist1 < dist2) then
            nearst=n
        else
            nearst=m
        endif
    else
        ifailed=1
    endif

    RETURN



    end SUBROUTINE FASTNEARHTPLA

      SUBROUTINE COFRM2 (DATE)
!          Assign DGRF/IGRF spherical harmonic coefficients, to degree and
!          order NMAX, for DATE, yyyy.fraction, into array G.  Coefficients
!          are interpolated from the DGRF dates through the current IGRF year.
!          Coefficients for a later DATE are extrapolated using the IGRF
!          initial value and the secular change coefficients.  A warning
!          message is issued if DATE is later than the last recommended
!          (5 yrs later than the IGRF).  An DATE input earlier than the
!          first DGRF (EPOCH(1)), results in a diagnostic and a STOP.
!
!          Output in COMMON /MAGCOF2/ NMAX,GB(144),GV(144),ICHG
!             NMAX = Maximum order of spherical harmonic coefficients used
!             GB   = Coefficients for magnetic field calculation
!             GV   = Coefficients for magnetic potential calculation
!             ICHG = Flag indicating when GB,GV have been changed in COFRM
!
!          HISTORY (blame):
!          COFRM and FELDG originated 15 Apr 83 by Vincent B. Wickwar
!          (formerly at SRI. Int., currently at Utah State).  Although set
!          up to accomodate second order time derivitives, the IGRF
!          (GTT, HTT) have been zero.  The spherical harmonic coefficients
!          degree and order is defined by NMAX (currently 10).
!
!          Jun 86:  Updated coefficients adding DGRF 1980 & IGRF 1985, which
!          were obtained from Eos Vol. 7, No. 24.  Common block MAG was
!          replaced by MAGCOF2, thus removing variables not used in subroutine
!          FELDG.  (Roy Barnes)
!
!          Apr 1992 (Barnes):  Added DGRF 1985 and IGRF 1990 as described
!          in EOS Vol 73 Number 16 Apr 21 1992.  Other changes were made so
!          future updates should:
!            (1) Increment NDGY;
!            (2) Append to EPOCH the next IGRF year;
!            (3) Append the next DGRF coefficients to G1DIM and H1DIM; and
!            (4) Replace the IGRF initial values (G0, GT) and rates of
!                change indices (H0, HT).
!
!          Apr 94 (Art Richmond): Computation of GV added, for finding
!          magnetic potential.
!
!          Aug 95 (Barnes):  Added DGRF for 1990 and IGRF for 1995, which were
!          obtained by anonymous ftp geomag.gsfc.nasa.gov (cd pub, mget table*)
!          as per instructions from Bob Langel (langel@geomag.gsfc.nasa.gov),
!          but, problems are to be reported to baldwin@geomag.gsfc.nasa.gov
 
!          Oct 95 (Barnes):  Correct error in IGRF-95 G 7 6 and H 8 7 (see
!          email in folder).  Also found bug whereby coefficients were not being
!          updated in FELDG when IENTY did not change. ICHG was added to flag
!          date changes.  Also, a vestigial switch (IS) was removed from COFRM:
!          It was always 0 and involved 3 branch if statements in the main
!          polynomial construction loop (now numbered 200).
 
!          Feb 99 (Barnes):  Explicitly initialize GV(1) in COFRM to avoid
!          possibility of compiler or loader options initializing memory
!          to something else (e.g., indefinite).  Also simplify the algebra
!          in COFRM; this does not effect results.

!          Mar 99 (Barnes):  Removed three branch if's from FELDG and changed
!          statement labels to ascending order

!          Jun 99 (Barnes):  Corrected RTOD definition in GD2CART.

!          May 00 (Barnes):  Replace IGRF 1995 with DGRF 1995, add IGRF
!          2000, and extend the earlier DGRF's backward to 1900.  A complete
!          set of coefficients came from a NGDC web page

!      implicit none

      integer ICHG,nmax , I , IY , I1
      integer N , M , NN , MM
      integer NDGY , NYT , NGH, ncoef
      REAL(kind=8) RNN
      REAL(kind=8) RTOD
      REAL(kind=8) DTOR
      REAL(kind=8) F , F0
!      REAL(kind=8) G , GV
!      REAL(kind=8) date , time , t

      PARAMETER (RTOD=57.2957795130823, DTOR=0.01745329251994330)
      parameter (ncoef = 196)
      COMMON /MAGCOF2/G(ncoef),GV(ncoef),ICHG,nmax
      DATA NMAX,ICHG /13,-99999/
 

      dimension gh(3256),g0(120),g1(120),g2(120),g3(120),g4(120), &
    	       g5(120),g6(120),g7(120),g8(120),g9(120),ga(120), &
    	       gb(120),gc(120),gd(120),ge(120),gf(120),gg(120), &
    	       gi(120),gj(120),gk(195),gl(195),gm(195),gp(195), &
    	       gq(195), &
    	       p(105),q(105),cl(13),sl(13)
      equivalence (g0,gh(1)),(g1,gh(121)),(g2,gh(241)),(g3,gh(361)), &
     		  (g4,gh(481)),(g5,gh(601)),(g6,gh(721)),(g7,gh(841)), &
     		  (g8,gh(961)),(g9,gh(1081)),(ga,gh(1201)), &
     		  (gb,gh(1321)),(gc,gh(1441)),(gd,gh(1561)), &
     		  (ge,gh(1681)),(gf,gh(1801)),(gg,gh(1921)), &
     		  (gi,gh(2041)),(gj,gh(2161)),(gk,gh(2281)), &
     		  (gl,gh(2476)),(gm,gh(2671)),(gp,gh(2866)), &
     		  (gq,gh(3061))
!
     data g0/ -31543.,-2298., 5922., -677., 2905.,-1061.,  924., 1121., &! 1900
     		1022.,-1469., -330., 1256.,    3.,  572.,  523.,  876., &! 1900
     		 628.,  195.,  660.,  -69., -361., -210.,  134.,  -75., &! 1900
     		-184.,  328., -210.,  264.,   53.,    5.,  -33.,  -86., &! 1900
     		-124.,  -16.,	 3.,   63.,   61.,   -9.,  -11.,   83., &! 1900
     		-217.,    2.,  -58.,  -35.,   59.,   36.,  -90.,  -69., &! 1900
     		  70.,  -55.,  -45.,	0.,  -13.,   34.,  -10.,  -41., &! 1900
     		  -1.,  -21.,	28.,   18.,  -12.,    6.,  -22.,   11., &! 1900
     		   8.,    8.,	-4.,  -14.,   -9.,    7.,    1.,  -13., &! 1900
     		   2.,    5.,	-9.,   16.,    5.,   -5.,    8.,  -18., &! 1900
     		   8.,   10.,  -20.,	1.,   14.,  -11.,    5.,   12., &! 1900
     		  -3.,    1.,	-2.,   -2.,    8.,    2.,   10.,   -1., &! 1900
     		  -2.,   -1.,	 2.,   -3.,   -4.,    2.,    2.,    1., &! 1900
     		  -5.,    2.,	-2.,	6.,    6.,   -4.,    4.,    0., &! 1900
     		   0.,   -2.,	 2.,	4.,    2.,    0.,    0.,   -6./  ! 1900
     data g1/ -31464.,-2298., 5909., -728., 2928.,-1086., 1041., 1065., &! 1905
     		1037.,-1494., -357., 1239.,   34.,  635.,  480.,  880., &! 1905
     		 643.,  203.,  653.,  -77., -380., -201.,  146.,  -65., &! 1905
     		-192.,  328., -193.,  259.,   56.,   -1.,  -32.,  -93., &! 1905
     		-125.,  -26.,	11.,   62.,   60.,   -7.,  -11.,   86., &! 1905
     		-221.,    4.,  -57.,  -32.,   57.,   32.,  -92.,  -67., &! 1905
     		  70.,  -54.,  -46.,	0.,  -14.,   33.,  -11.,  -41., &! 1905
     		   0.,  -20.,	28.,   18.,  -12.,    6.,  -22.,   11., &! 1905
     		   8.,    8.,	-4.,  -15.,   -9.,    7.,    1.,  -13., &! 1905
     		   2.,    5.,	-8.,   16.,    5.,   -5.,    8.,  -18., &! 1905
     		   8.,   10.,  -20.,	1.,   14.,  -11.,    5.,   12., &! 1905
     		  -3.,    1.,	-2.,   -2.,    8.,    2.,   10.,    0., &! 1905
     		  -2.,   -1.,	 2.,   -3.,   -4.,    2.,    2.,    1., &! 1905
     		  -5.,    2.,	-2.,	6.,    6.,   -4.,    4.,    0., &! 1905
     		   0.,   -2.,	 2.,	4.,    2.,    0.,    0.,   -6./  !1905
     data g2/ -31354.,-2297., 5898., -769., 2948.,-1128., 1176., 1000., &! 1910
     		1058.,-1524., -389., 1223.,   62.,  705.,  425.,  884., &! 1910
     		 660.,  211.,  644.,  -90., -400., -189.,  160.,  -55., &! 1910
     		-201.,  327., -172.,  253.,   57.,   -9.,  -33., -102., &! 1910
     		-126.,  -38.,	21.,   62.,   58.,   -5.,  -11.,   89., &! 1910
     		-224.,    5.,  -54.,  -29.,   54.,   28.,  -95.,  -65., &! 1910
     		  71.,  -54.,  -47.,	1.,  -14.,   32.,  -12.,  -40., &! 1910
     		   1.,  -19.,	28.,   18.,  -13.,    6.,  -22.,   11., &! 1910
     		   8.,    8.,	-4.,  -15.,   -9.,    6.,    1.,  -13., &! 1910
     		   2.,    5.,	-8.,   16.,    5.,   -5.,    8.,  -18., &! 1910
     		   8.,   10.,  -20.,	1.,   14.,  -11.,    5.,   12., &! 1910
     		  -3.,    1.,	-2.,   -2.,    8.,    2.,   10.,    0., &! 1910
     		  -2.,   -1.,	 2.,   -3.,   -4.,    2.,    2.,    1., &! 1910
     		  -5.,    2.,	-2.,	6.,    6.,   -4.,    4.,    0., &! 1910
     		   0.,   -2.,	 2.,	4.,    2.,    0.,    0.,   -6./  ! 1910
     data g3/ -31212.,-2306., 5875., -802., 2956.,-1191., 1309.,  917., &! 1915
     		1084.,-1559., -421., 1212.,   84.,  778.,  360.,  887., &! 1915
     		 678.,  218.,  631., -109., -416., -173.,  178.,  -51., &! 1915
     		-211.,  327., -148.,  245.,   58.,  -16.,  -34., -111., &! 1915
     		-126.,  -51.,	32.,   61.,   57.,   -2.,  -10.,   93., &! 1915
     		-228.,    8.,  -51.,  -26.,   49.,   23.,  -98.,  -62., &! 1915
     		  72.,  -54.,  -48.,	2.,  -14.,   31.,  -12.,  -38., &! 1915
     		   2.,  -18.,	28.,   19.,  -15.,    6.,  -22.,   11., &! 1915
     		   8.,    8.,	-4.,  -15.,   -9.,    6.,    2.,  -13., &! 1915
     		   3.,    5.,	-8.,   16.,    6.,   -5.,    8.,  -18., &! 1915
     		   8.,   10.,  -20.,	1.,   14.,  -11.,    5.,   12., &! 1915
     		  -3.,    1.,	-2.,   -2.,    8.,    2.,   10.,    0., &! 1915
     		  -2.,   -1.,	 2.,   -3.,   -4.,    2.,    2.,    1., &! 1915
     		  -5.,    2.,	-2.,	6.,    6.,   -4.,    4.,    0., &! 1915
     		   0.,   -2.,	 1.,	4.,    2.,    0.,    0.,   -6./  ! 1915
     data g4/ -31060.,-2317., 5845., -839., 2959.,-1259., 1407.,  823., &! 1920
     		1111.,-1600., -445., 1205.,  103.,  839.,  293.,  889., &! 1920
     		 695.,  220.,  616., -134., -424., -153.,  199.,  -57., &! 1920
     		-221.,  326., -122.,  236.,   58.,  -23.,  -38., -119., &! 1920
     		-125.,  -62.,	43.,   61.,   55.,    0.,  -10.,   96., &! 1920
     		-233.,   11.,  -46.,  -22.,   44.,   18., -101.,  -57., &! 1920
     		  73.,  -54.,  -49.,	2.,  -14.,   29.,  -13.,  -37., &! 1920
     		   4.,  -16.,	28.,   19.,  -16.,    6.,  -22.,   11., &! 1920
     		   7.,    8.,	-3.,  -15.,   -9.,    6.,    2.,  -14., &! 1920
     		   4.,    5.,	-7.,   17.,    6.,   -5.,    8.,  -19., &! 1920
     		   8.,   10.,  -20.,	1.,   14.,  -11.,    5.,   12., &! 1920
     		  -3.,    1.,	-2.,   -2.,    9.,    2.,   10.,    0., &! 1920
     		  -2.,   -1.,	 2.,   -3.,   -4.,    2.,    2.,    1., &! 1920
     		  -5.,    2.,	-2.,	6.,    6.,   -4.,    4.,    0., &! 1920
     		   0.,   -2.,	 1.,	4.,    3.,    0.,    0.,   -6./  ! 1920
     data g5/ -30926.,-2318., 5817., -893., 2969.,-1334., 1471.,  728., &! 1925
     		1140.,-1645., -462., 1202.,  119.,  881.,  229.,  891., &! 1925
     		 711.,  216.,  601., -163., -426., -130.,  217.,  -70., &! 1925
     		-230.,  326.,  -96.,  226.,   58.,  -28.,  -44., -125., &! 1925
     		-122.,  -69.,	51.,   61.,   54.,    3.,   -9.,   99., &! 1925
     		-238.,   14.,  -40.,  -18.,   39.,   13., -103.,  -52., &! 1925
     		  73.,  -54.,  -50.,	3.,  -14.,   27.,  -14.,  -35., &! 1925
     		   5.,  -14.,	29.,   19.,  -17.,    6.,  -21.,   11., &! 1925
     		   7.,    8.,	-3.,  -15.,   -9.,    6.,    2.,  -14., &! 1925
     		   4.,    5.,	-7.,   17.,    7.,   -5.,    8.,  -19., &! 1925
     		   8.,   10.,  -20.,	1.,   14.,  -11.,    5.,   12., &! 1925
     		  -3.,    1.,	-2.,   -2.,    9.,    2.,   10.,    0., &! 1925
     		  -2.,   -1.,	 2.,   -3.,   -4.,    2.,    2.,    1., &! 1925
     		  -5.,    2.,	-2.,	6.,    6.,   -4.,    4.,    0., &! 1925
     		   0.,   -2.,	 1.,	4.,    3.,    0.,    0.,   -6./  ! 1925
     data g6/ -30805.,-2316., 5808., -951., 2980.,-1424., 1517.,  644., &! 1930
     		1172.,-1692., -480., 1205.,  133.,  907.,  166.,  896., &! 1930
     		 727.,  205.,  584., -195., -422., -109.,  234.,  -90., &! 1930
     		-237.,  327.,  -72.,  218.,   60.,  -32.,  -53., -131., &! 1930
     		-118.,  -74.,	58.,   60.,   53.,    4.,   -9.,  102., &! 1930
     		-242.,   19.,  -32.,  -16.,   32.,    8., -104.,  -46., &! 1930
     		  74.,  -54.,  -51.,	4.,  -15.,   25.,  -14.,  -34., &! 1930
     		   6.,  -12.,	29.,   18.,  -18.,    6.,  -20.,   11., &! 1930
     		   7.,    8.,	-3.,  -15.,   -9.,    5.,    2.,  -14., &! 1930
     		   5.,    5.,	-6.,   18.,    8.,   -5.,    8.,  -19., &! 1930
     		   8.,   10.,  -20.,	1.,   14.,  -12.,    5.,   12., &! 1930
     		  -3.,    1.,	-2.,   -2.,    9.,    3.,   10.,    0., &! 1930
     		  -2.,   -2.,	 2.,   -3.,   -4.,    2.,    2.,    1., &! 1930
     		  -5.,    2.,	-2.,	6.,    6.,   -4.,    4.,    0., &! 1930
     		   0.,   -2.,	 1.,	4.,    3.,    0.,    0.,   -6./  ! 1930
     data g7/ -30715.,-2306., 5812.,-1018., 2984.,-1520., 1550.,  586., &! 1935
     		1206.,-1740., -494., 1215.,  146.,  918.,  101.,  903., &! 1935
     		 744.,  188.,  565., -226., -415.,  -90.,  249., -114., &! 1935
     		-241.,  329.,  -51.,  211.,   64.,  -33.,  -64., -136., &! 1935
     		-115.,  -76.,	64.,   59.,   53.,    4.,   -8.,  104., &! 1935
     		-246.,   25.,  -25.,  -15.,   25.,    4., -106.,  -40., &! 1935
     		  74.,  -53.,  -52.,	4.,  -17.,   23.,  -14.,  -33., &! 1935
     		   7.,  -11.,	29.,   18.,  -19.,    6.,  -19.,   11., &! 1935
     		   7.,    8.,	-3.,  -15.,   -9.,    5.,    1.,  -15., &! 1935
     		   6.,    5.,	-6.,   18.,    8.,   -5.,    7.,  -19., &! 1935
     		   8.,   10.,  -20.,	1.,   15.,  -12.,    5.,   11., &! 1935
     		  -3.,    1.,	-3.,   -2.,    9.,    3.,   11.,    0., &! 1935
     		  -2.,   -2.,	 2.,   -3.,   -4.,    2.,    2.,    1., &! 1935
     		  -5.,    2.,	-2.,	6.,    6.,   -4.,    4.,    0., &! 1935
     		   0.,   -1.,	 2.,	4.,    3.,    0.,    0.,   -6./  ! 1935
     data g8/ -30654.,-2292., 5821.,-1106., 2981.,-1614., 1566.,  528., &! 1940
     		1240.,-1790., -499., 1232.,  163.,  916.,   43.,  914., &! 1940
     		 762.,  169.,  550., -252., -405.,  -72.,  265., -141., &! 1940
     		-241.,  334.,  -33.,  208.,   71.,  -33.,  -75., -141., &! 1940
     		-113.,  -76.,	69.,   57.,   54.,    4.,   -7.,  105., &! 1940
     		-249.,   33.,  -18.,  -15.,   18.,    0., -107.,  -33., &! 1940
     		  74.,  -53.,  -52.,	4.,  -18.,   20.,  -14.,  -31., &! 1940
     		   7.,   -9.,	29.,   17.,  -20.,    5.,  -19.,   11., &! 1940
     		   7.,    8.,	-3.,  -14.,  -10.,    5.,    1.,  -15., &! 1940
     		   6.,    5.,	-5.,   19.,    9.,   -5.,    7.,  -19., &! 1940
     		   8.,   10.,  -21.,	1.,   15.,  -12.,    5.,   11., &! 1940
     		  -3.,    1.,	-3.,   -2.,    9.,    3.,   11.,    1., &! 1940
     		  -2.,   -2.,	 2.,   -3.,   -4.,    2.,    2.,    1., &! 1940
     		  -5.,    2.,	-2.,	6.,    6.,   -4.,    4.,    0., &! 1940
     		   0.,   -1.,	 2.,	4.,    3.,    0.,    0.,   -6./  ! 1940
     data g9/ -30594.,-2285., 5810.,-1244., 2990.,-1702., 1578.,  477., &! 1945
     		1282.,-1834., -499., 1255.,  186.,  913.,  -11.,  944., &! 1945
     		 776.,  144.,  544., -276., -421.,  -55.,  304., -178., &! 1945
     		-253.,  346.,  -12.,  194.,   95.,  -20.,  -67., -142., &! 1945
     		-119.,  -82.,	82.,   59.,   57.,    6.,    6.,  100., &! 1945
     		-246.,   16.,  -25.,   -9.,   21.,  -16., -104.,  -39., &! 1945
     		  70.,  -40.,  -45.,	0.,  -18.,    0.,    2.,  -29., &! 1945
     		   6.,  -10.,	28.,   15.,  -17.,   29.,  -22.,   13., &! 1945
     		   7.,   12.,	-8.,  -21.,   -5.,  -12.,    9.,   -7., &! 1945
     		   7.,    2.,  -10.,   18.,    7.,    3.,    2.,  -11., &! 1945
     		   5.,  -21.,  -27.,	1.,   17.,  -11.,   29.,    3., &! 1945
     		  -9.,   16.,	 4.,   -3.,    9.,   -4.,    6.,   -3., &! 1945
     		   1.,   -4.,	 8.,   -3.,   11.,    5.,    1.,    1., &! 1945
     		   2.,  -20.,	-5.,   -1.,   -1.,   -6.,    8.,    6., &! 1945
     		  -1.,   -4.,	-3.,   -2.,    5.,    0.,   -2.,   -2./  ! 1945
     data ga/ -30554.,-2250., 5815.,-1341., 2998.,-1810., 1576.,  381., &! 1950
     		1297.,-1889., -476., 1274.,  206.,  896.,  -46.,  954., &! 1950
     		 792.,  136.,  528., -278., -408.,  -37.,  303., -210., &! 1950
     		-240.,  349.,	 3.,  211.,  103.,  -20.,  -87., -147., &! 1950
     		-122.,  -76.,	80.,   54.,   57.,   -1.,    4.,   99., &! 1950
     		-247.,   33.,  -16.,  -12.,   12.,  -12., -105.,  -30., &! 1950
     		  65.,  -55.,  -35.,	2.,  -17.,    1.,    0.,  -40., &! 1950
     		  10.,   -7.,	36.,	5.,  -18.,   19.,  -16.,   22., &! 1950
     		  15.,    5.,	-4.,  -22.,   -1.,    0.,   11.,  -21., &! 1950
     		  15.,   -8.,  -13.,   17.,    5.,   -4.,   -1.,  -17., &! 1950
     		   3.,   -7.,  -24.,   -1.,   19.,  -25.,   12.,   10., &! 1950
     		   2.,    5.,	 2.,   -5.,    8.,   -2.,    8.,    3., &! 1950
     		 -11.,    8.,	-7.,   -8.,    4.,   13.,   -1.,   -2., &! 1950
     		  13.,  -10.,	-4.,	2.,    4.,   -3.,   12.,    6., &! 1950
     		   3.,   -3.,	 2.,	6.,   10.,   11.,    3.,    8./  ! 1950
     data gb/ -30500.,-2215., 5820.,-1440., 3003.,-1898., 1581.,  291., &! 1955
     		1302.,-1944., -462., 1288.,  216.,  882.,  -83.,  958., &! 1955
     		 796.,  133.,  510., -274., -397.,  -23.,  290., -230., &! 1955
     		-229.,  360.,	15.,  230.,  110.,  -23.,  -98., -152., &! 1955
     		-121.,  -69.,	78.,   47.,   57.,   -9.,    3.,   96., &! 1955
     		-247.,   48.,	-8.,  -16.,    7.,  -12., -107.,  -24., &! 1955
     		  65.,  -56.,  -50.,	2.,  -24.,   10.,   -4.,  -32., &! 1955
     		   8.,  -11.,	28.,	9.,  -20.,   18.,  -18.,   11., &! 1955
     		   9.,   10.,	-6.,  -15.,  -14.,    5.,    6.,  -23., &! 1955
     		  10.,    3.,	-7.,   23.,    6.,   -4.,    9.,  -13., &! 1955
     		   4.,    9.,  -11.,   -4.,   12.,   -5.,    7.,    2., &! 1955
     		   6.,    4.,	-2.,	1.,   10.,    2.,    7.,    2., &! 1955
     		  -6.,    5.,	 5.,   -3.,   -5.,   -4.,   -1.,    0., &! 1955
     		   2.,   -8.,	-3.,   -2.,    7.,   -4.,    4.,    1., &! 1955
     		  -2.,   -3.,	 6.,	7.,   -2.,   -1.,    0.,   -3./  ! 1955
     data gc/ -30421.,-2169., 5791.,-1555., 3002.,-1967., 1590.,  206., &! 1960
     		1302.,-1992., -414., 1289.,  224.,  878., -130.,  957., &! 1960
     		 800.,  135.,  504., -278., -394.,    3.,  269., -255., &! 1960
     		-222.,  362.,	16.,  242.,  125.,  -26., -117., -156., &! 1960
     		-114.,  -63.,	81.,   46.,   58.,  -10.,    1.,   99., &! 1960
     		-237.,   60.,	-1.,  -20.,   -2.,  -11., -113.,  -17., &! 1960
     		  67.,  -56.,  -55.,	5.,  -28.,   15.,   -6.,  -32., &! 1960
     		   7.,   -7.,	23.,   17.,  -18.,    8.,  -17.,   15., &! 1960
     		   6.,   11.,	-4.,  -14.,  -11.,    7.,    2.,  -18., &! 1960
     		  10.,    4.,	-5.,   23.,   10.,    1.,    8.,  -20., &! 1960
     		   4.,    6.,  -18.,	0.,   12.,   -9.,    2.,    1., &! 1960
     		   0.,    4.,	-3.,   -1.,    9.,   -2.,    8.,    3., &! 1960
     		   0.,   -1.,	 5.,	1.,   -3.,    4.,    4.,    1., &! 1960
     		   0.,    0.,	-1.,	2.,    4.,   -5.,    6.,    1., &! 1960
     		   1.,   -1.,	-1.,	6.,    2.,    0.,    0.,   -7./  ! 1960
     data gd/ -30334.,-2119., 5776.,-1662., 2997.,-2016., 1594.,  114., &! 1965
     		1297.,-2038., -404., 1292.,  240.,  856., -165.,  957., &! 1965
     		 804.,  148.,  479., -269., -390.,   13.,  252., -269., &! 1965
     		-219.,  358.,	19.,  254.,  128.,  -31., -126., -157., &! 1965
     		 -97.,  -62.,	81.,   45.,   61.,  -11.,    8.,  100., &! 1965
     		-228.,   68.,	 4.,  -32.,    1.,   -8., -111.,   -7., &! 1965
     		  75.,  -57.,  -61.,	4.,  -27.,   13.,   -2.,  -26., &! 1965
     		   6.,   -6.,	26.,   13.,  -23.,    1.,  -12.,   13., &! 1965
     		   5.,    7.,	-4.,  -12.,  -14.,    9.,    0.,  -16., &! 1965
     		   8.,    4.,	-1.,   24.,   11.,   -3.,    4.,  -17., &! 1965
     		   8.,   10.,  -22.,	2.,   15.,  -13.,    7.,   10., &! 1965
     		  -4.,   -1.,	-5.,   -1.,   10.,    5.,   10.,    1., &! 1965
     		  -4.,   -2.,	 1.,   -2.,   -3.,    2.,    2.,    1., &! 1965
     		  -5.,    2.,	-2.,	6.,    4.,   -4.,    4.,    0., &! 1965
     		   0.,   -2.,	 2.,	3.,    2.,    0.,    0.,   -6./  ! 1965
     data ge/ -30220.,-2068., 5737.,-1781., 3000.,-2047., 1611.,   25., &! 1970
     		1287.,-2091., -366., 1278.,  251.,  838., -196.,  952., &! 1970
     		 800.,  167.,  461., -266., -395.,   26.,  234., -279., &! 1970
     		-216.,  359.,	26.,  262.,  139.,  -42., -139., -160., &! 1970
     		 -91.,  -56.,	83.,   43.,   64.,  -12.,   15.,  100., &! 1970
     		-212.,   72.,	 2.,  -37.,    3.,   -6., -112.,    1., &! 1970
     		  72.,  -57.,  -70.,	1.,  -27.,   14.,   -4.,  -22., &! 1970
     		   8.,   -2.,	23.,   13.,  -23.,   -2.,  -11.,   14., &! 1970
     		   6.,    7.,	-2.,  -15.,  -13.,    6.,   -3.,  -17., &! 1970
     		   5.,    6.,	 0.,   21.,   11.,   -6.,    3.,  -16., &! 1970
     		   8.,   10.,  -21.,	2.,   16.,  -12.,    6.,   10., &! 1970
     		  -4.,   -1.,	-5.,	0.,   10.,    3.,   11.,    1., &! 1970
     		  -2.,   -1.,	 1.,   -3.,   -3.,    1.,    2.,    1., &! 1970
     		  -5.,    3.,	-1.,	4.,    6.,   -4.,    4.,    0., &! 1970
     		   1.,   -1.,	 0.,	3.,    3.,    1.,   -1.,   -4./  ! 1970
     data gf/ -30100.,-2013., 5675.,-1902., 3010.,-2067., 1632.,  -68., &! 1975
     		1276.,-2144., -333., 1260.,  262.,  830., -223.,  946., &! 1975
     		 791.,  191.,  438., -265., -405.,   39.,  216., -288., &! 1975
     		-218.,  356.,	31.,  264.,  148.,  -59., -152., -159., &! 1975
     		 -83.,  -49.,	88.,   45.,   66.,  -13.,   28.,   99., &! 1975
     		-198.,   75.,	 1.,  -41.,    6.,   -4., -111.,   11., &! 1975
     		  71.,  -56.,  -77.,	1.,  -26.,   16.,   -5.,  -14., &! 1975
     		  10.,    0.,	22.,   12.,  -23.,   -5.,  -12.,   14., &! 1975
     		   6.,    6.,	-1.,  -16.,  -12.,    4.,   -8.,  -19., &! 1975
     		   4.,    6.,	 0.,   18.,   10.,  -10.,    1.,  -17., &! 1975
     		   7.,   10.,  -21.,	2.,   16.,  -12.,    7.,   10., &! 1975
     		  -4.,   -1.,	-5.,   -1.,   10.,    4.,   11.,    1., &! 1975
     		  -3.,   -2.,	 1.,   -3.,   -3.,    1.,    2.,    1., &! 1975
     		  -5.,    3.,	-2.,	4.,    5.,   -4.,    4.,   -1., &! 1975
     		   1.,   -1.,	 0.,	3.,    3.,    1.,   -1.,   -5./  ! 1975
     data gg/ -29992.,-1956., 5604.,-1997., 3027.,-2129., 1663., -200., &! 1980
     		1281.,-2180., -336., 1251.,  271.,  833., -252.,  938., &! 1980
     		 782.,  212.,  398., -257., -419.,   53.,  199., -297., &! 1980
     		-218.,  357.,	46.,  261.,  150.,  -74., -151., -162., &! 1980
     		 -78.,  -48.,	92.,   48.,   66.,  -15.,   42.,   93., &! 1980
     		-192.,   71.,	 4.,  -43.,   14.,   -2., -108.,   17., &! 1980
     		  72.,  -59.,  -82.,	2.,  -27.,   21.,   -5.,  -12., &! 1980
     		  16.,    1.,	18.,   11.,  -23.,   -2.,  -10.,   18., &! 1980
     		   6.,    7.,	 0.,  -18.,  -11.,    4.,   -7.,  -22., &! 1980
     		   4.,    9.,	 3.,   16.,    6.,  -13.,   -1.,  -15., &! 1980
     		   5.,   10.,  -21.,	1.,   16.,  -12.,    9.,    9., &! 1980
     		  -5.,   -3.,	-6.,   -1.,    9.,    7.,   10.,    2., &! 1980
     		  -6.,   -5.,	 2.,   -4.,   -4.,    1.,    2.,    0., &! 1980
     		  -5.,    3.,	-2.,	6.,    5.,   -4.,    3.,    0., &! 1980
     		   1.,   -1.,	 2.,	4.,    3.,    0.,    0.,   -6./  ! 1980
     data gi/ -29873.,-1905., 5500.,-2072., 3044.,-2197., 1687., -306., &! 1985
     		1296.,-2208., -310., 1247.,  284.,  829., -297.,  936., &! 1985
     		 780.,  232.,  361., -249., -424.,   69.,  170., -297., &! 1985
     		-214.,  355.,	47.,  253.,  150.,  -93., -154., -164., &! 1985
     		 -75.,  -46.,	95.,   53.,   65.,  -16.,   51.,   88., &! 1985
     		-185.,   69.,	 4.,  -48.,   16.,   -1., -102.,   21., &! 1985
     		  74.,  -62.,  -83.,	3.,  -27.,   24.,   -2.,   -6., &! 1985
     		  20.,    4.,	17.,   10.,  -23.,    0.,   -7.,   21., &! 1985
     		   6.,    8.,	 0.,  -19.,  -11.,    5.,   -9.,  -23., &! 1985
     		   4.,   11.,	 4.,   14.,    4.,  -15.,   -4.,  -11., &! 1985
     		   5.,   10.,  -21.,	1.,   15.,  -12.,    9.,    9., &! 1985
     		  -6.,   -3.,	-6.,   -1.,    9.,    7.,    9.,    1., &! 1985
     		  -7.,   -5.,	 2.,   -4.,   -4.,    1.,    3.,    0., &! 1985
     		  -5.,    3.,	-2.,	6.,    5.,   -4.,    3.,    0., &! 1985
     		   1.,   -1.,	 2.,	4.,    3.,    0.,    0.,   -6./  ! 1985
     data gj/ -29775.,-1848., 5406.,-2131., 3059.,-2279., 1686., -373., &! 1990
     		1314.,-2239., -284., 1248.,  293.,  802., -352.,  939., &! 1990
     		 780.,  247.,  325., -240., -423.,   84.,  141., -299., &! 1990
     		-214.,  353.,	46.,  245.,  154., -109., -153., -165., &! 1990
     		 -69.,  -36.,	97.,   61.,   65.,  -16.,   59.,   82., &! 1990
     		-178.,   69.,	 3.,  -52.,   18.,    1.,  -96.,   24., &! 1990
     		  77.,  -64.,  -80.,	2.,  -26.,   26.,    0.,   -1., &! 1990
     		  21.,    5.,	17.,	9.,  -23.,    0.,   -4.,   23., &! 1990
     		   5.,   10.,	-1.,  -19.,  -10.,    6.,  -12.,  -22., &! 1990
     		   3.,   12.,	 4.,   12.,    2.,  -16.,   -6.,  -10., &! 1990
     		   4.,    9.,  -20.,	1.,   15.,  -12.,   11.,    9., &! 1990
     		  -7.,   -4.,	-7.,   -2.,    9.,    7.,    8.,    1., &! 1990
     		  -7.,   -6.,	 2.,   -3.,   -4.,    2.,    2.,    1., &! 1990
     		  -5.,    3.,	-2.,	6.,    4.,   -4.,    3.,    0., &! 1990
     		   1.,   -2.,	 3.,	3.,    3.,   -1.,    0.,   -6./  ! 1990
     data gk/ -29692.,-1784., 5306.,-2200., 3070.,-2366., 1681., -413., &! 1995
     		1335.,-2267., -262., 1249.,  302.,  759., -427.,  940., &! 1995
     		 780.,  262.,  290., -236., -418.,   97.,  122., -306., &! 1995
     		-214.,  352.,	46.,  235.,  165., -118., -143., -166., &! 1995
     		 -55.,  -17.,  107.,   68.,   67.,  -17.,   68.,   72., &! 1995
     		-170.,   67.,	-1.,  -58.,   19.,    1.,  -93.,   36., &! 1995
     		  77.,  -72.,  -69.,	1.,  -25.,   28.,    4.,    5., &! 1995
     		  24.,    4.,	17.,	8.,  -24.,   -2.,   -6.,   25., &! 1995
     		   6.,   11.,	-6.,  -21.,   -9.,    8.,  -14.,  -23., &! 1995
     		   9.,   15.,	 6.,   11.,   -5.,  -16.,   -7.,   -4., &! 1995
     		   4.,    9.,  -20.,	3.,   15.,  -10.,   12.,    8., &! 1995
     		  -6.,   -8.,	-8.,   -1.,    8.,   10.,    5.,   -2., &! 1995
     		  -8.,   -8.,	 3.,   -3.,   -6.,    1.,    2.,    0., &! 1995
     		  -4.,    4.,	-1.,	5.,    4.,   -5.,    2.,   -1., &! 1995
     		   2.,   -2.,	 5.,	1.,    1.,   -2.,    0.,   -7., &! 1995
     		75*0./  						 ! 1995
     data gl/ -29619.4,-1728.2, 5186.1,-2267.7, 3068.4,-2481.6, 1670.9, &! 2000
     		-458.0, 1339.6,-2288.0, -227.6, 1252.1,  293.4,  714.5, &! 2000
     		-491.1,  932.3,  786.8,  272.6,  250.0, -231.9, -403.0, &! 2000
     		 119.8,  111.3, -303.8, -218.8,  351.4,   43.8,  222.3, &! 2000
     		 171.9, -130.4, -133.1, -168.6,  -39.3,  -12.9,  106.3, &! 2000
     		  72.3,   68.2,  -17.4,   74.2,   63.7, -160.9,   65.1, &! 2000
     		  -5.9,  -61.2,   16.9,    0.7,  -90.4,   43.8,   79.0, &! 2000
     		 -74.0,  -64.6,    0.0,  -24.2,   33.3,    6.2,    9.1, &! 2000
     		  24.0,    6.9,   14.8,    7.3,  -25.4,   -1.2,   -5.8, &! 2000
     		  24.4,    6.6,   11.9,   -9.2,  -21.5,   -7.9,    8.5, &! 2000
     		 -16.6,  -21.5,    9.1,   15.5,    7.0,    8.9,   -7.9, &! 2000
     		 -14.9,   -7.0,   -2.1,    5.0,    9.4,  -19.7,    3.0, &! 2000
     		  13.4,   -8.4,   12.5,    6.3,   -6.2,   -8.9,   -8.4, &! 2000
     		  -1.5,    8.4,    9.3,    3.8,   -4.3,   -8.2,   -8.2, &! 2000
     		   4.8,   -2.6,   -6.0,    1.7,    1.7,    0.0,   -3.1, &! 2000
     		   4.0,   -0.5,    4.9,    3.7,   -5.9,    1.0,   -1.2, &! 2000
     		   2.0,   -2.9,    4.2,    0.2,    0.3,   -2.2,   -1.1, &! 2000
     		  -7.4,    2.7,   -1.7,    0.1,   -1.9,    1.3,    1.5, &! 2000
     		  -0.9,   -0.1,   -2.6,    0.1,    0.9,   -0.7,   -0.7, &! 2000
     		   0.7,   -2.8,    1.7,   -0.9,    0.1,   -1.2,    1.2, &! 2000
     		  -1.9,    4.0,   -0.9,   -2.2,   -0.3,   -0.4,    0.2, &! 2000
     		   0.3,    0.9,    2.5,   -0.2,   -2.6,    0.9,    0.7, &! 2000
     		  -0.5,    0.3,    0.3,    0.0,   -0.3,    0.0,   -0.4, &! 2000
     		   0.3,   -0.1,   -0.9,   -0.2,   -0.4,   -0.4,    0.8, &! 2000
     		  -0.2,   -0.9,   -0.9,    0.3,    0.2,    0.1,    1.8, &! 2000
     		  -0.4,   -0.4,    1.3,   -1.0,   -0.4,   -0.1,    0.7, &! 2000
     		   0.7,   -0.4,    0.3,    0.3,    0.6,   -0.1,    0.3, &! 2000
     		   0.4,   -0.2,    0.0,   -0.5,    0.1,   -0.9/ 	!  2000
     data gm/-29554.63,-1669.05, 5077.99,-2337.24, 3047.69,-2594.50, &!   2005
     	       1657.76, -515.43, 1336.30,-2305.83, -198.86, 1246.39, &!   2005
     		269.72,  672.51, -524.72,  920.55,  797.96,  282.07, &!   2005
     		210.65, -225.23, -379.86,  145.15,  100.00, -305.36, &!   2005
     	       -227.00,  354.41,   42.72,  208.95,  180.25, -136.54, &!   2005
     	       -123.45, -168.05,  -19.57,  -13.55,  103.85,   73.60, &!   2005
     		 69.56,  -20.33,   76.74,   54.75, -151.34,   63.63, &!   2005
     		-14.58,  -63.53,   14.58,    0.24,  -86.36,   50.94, &!   2005
     		 79.88,  -74.46,  -61.14,   -1.65,  -22.57,   38.73, &!   2005
     		  6.82,   12.30,   25.35,    9.37,   10.93,    5.42, &!   2005
     		-26.32,    1.94,   -4.64,   24.80,    7.62,   11.20, &!   2005
     		-11.73,  -20.88,   -6.88,    9.83,  -18.11,  -19.71, &!   2005
     		 10.17,   16.22,    9.36,    7.61,  -11.25,  -12.76, &!   2005
     		 -4.87,   -0.06,    5.58,    9.76,  -20.11,    3.58, &!   2005
     		 12.69,   -6.94,   12.67,    5.01,   -6.72,  -10.76, &!   2005
     		 -8.16,   -1.25,    8.10,    8.76,    2.92,   -6.66, &!   2005
     		 -7.73,   -9.22,    6.01,   -2.17,   -6.12,    2.19, &!   2005
     		  1.42,    0.10,   -2.35,    4.46,   -0.15,    4.76, &!   2005
     		  3.06,   -6.58,    0.29,   -1.01,    2.06,   -3.47, &!   2005
     		  3.77,   -0.86,   -0.21,   -2.31,   -2.09,   -7.93, &!   2005
     		  2.95,   -1.60,    0.26,   -1.88,    1.44,    1.44, &!   2005
     		 -0.77,   -0.31,   -2.27,    0.29,    0.90,   -0.79, &!   2005
     		 -0.58,    0.53,   -2.69,    1.80,   -1.08,    0.16, &!   2005
     		 -1.58,    0.96,   -1.90,    3.99,   -1.39,   -2.15, &!   2005
     		 -0.29,   -0.55,    0.21,    0.23,    0.89,    2.38, &!   2005
     		 -0.38,   -2.63,    0.96,    0.61,   -0.30,    0.40, &!   2005
     		  0.46,    0.01,   -0.35,    0.02,   -0.36,    0.28, &!   2005
     		  0.08,   -0.87,   -0.49,   -0.34,   -0.08,    0.88, &!    2005
     		 -0.16,   -0.88,   -0.76,    0.30,    0.33,    0.28, &!   2005
     		  1.72,   -0.43,   -0.54,    1.18,   -1.07,   -0.37, &!   2005
     		 -0.04,    0.75,    0.63,   -0.26,    0.21,    0.35, &!   2005
     		  0.53,   -0.05,    0.38,    0.41,   -0.22,   -0.10, &!   2005
     		 -0.57,   -0.18,   -0.82/				!2005
     data gp/-29496.5,-1585.9, 4945.1,-2396.6, 3026.0,-2707.7, 1668.6, &!  2010
     	       -575.4, 1339.7,-2326.3, -160.5, 1231.7,  251.7,  634.2, &! 2010
     	       -536.8,  912.6,  809.0,  286.4,  166.6, -211.2, -357.1, &! 2010
     		164.4,   89.7, -309.2, -231.1,  357.2,   44.7,  200.3, &! 2010
     		188.9, -141.2, -118.1, -163.1,    0.1,   -7.7,  100.9, &! 2010
     		 72.8,   68.6,  -20.8,   76.0,   44.2, -141.4,   61.5, &! 2010
     		-22.9,  -66.3,   13.1,    3.1,  -77.9,   54.9,   80.4, &! 2010
     		-75.0,  -57.8,   -4.7,  -21.2,   45.3,    6.6,   14.0, &! 2010
     		 24.9,   10.4,    7.0,    1.6,  -27.7,    4.9,   -3.4, &! 2010
     		 24.3,    8.2,   10.9,  -14.5,  -20.0,   -5.7,   11.9, &! 2010
     		-19.3,  -17.4,   11.6,   16.7,   10.9,    7.1,  -14.1, &! 2010
     		-10.8,   -3.7,    1.7,    5.4,    9.4,  -20.5,    3.4, &! 2010
     		 11.6,   -5.3,   12.8,    3.1,   -7.2,  -12.4,   -7.4, &! 2010
     		 -0.8,    8.0,    8.4,    2.2,   -8.4,   -6.1,  -10.1, &! 2010
     		  7.0,   -2.0,   -6.3,    2.8,    0.9,   -0.1,   -1.1, &! 2010
     		  4.7,   -0.2,    4.4,    2.5,   -7.2,   -0.3,   -1.0, &! 2010
     		  2.2,   -4.0,    3.1,   -2.0,   -1.0,   -2.0,   -2.8, &! 2010
     		 -8.3,    3.0,   -1.5,    0.1,   -2.1,    1.7,    1.6, &! 2010
     		 -0.6,   -0.5,   -1.8,    0.5,    0.9,   -0.8,   -0.4, &! 2010
     		  0.4,   -2.5,    1.8,   -1.3,    0.2,   -2.1,    0.8, &! 2010
     		 -1.9,    3.8,   -1.8,   -2.1,   -0.2,   -0.8,    0.3, &! 2010
     		  0.3,    1.0,    2.2,   -0.7,   -2.5,    0.9,    0.5, &! 2010
     		 -0.1,    0.6,    0.5,    0.0,   -0.4,    0.1,   -0.4, &! 2010
     		  0.3,    0.2,   -0.9,   -0.8,   -0.2,    0.0,    0.8, &! 2010
     		 -0.2,   -0.9,   -0.8,    0.3,    0.3,    0.4,    1.7, &! 2010
     		 -0.4,   -0.6,    1.1,   -1.2,   -0.3,   -0.1,    0.8, &! 2010
     		  0.5,   -0.2,    0.1,    0.4,    0.5,    0.0,    0.4, &! 2010
     		  0.4,   -0.2,   -0.3,   -0.5,   -0.3,   -0.8/         !  2010
     data gq/	 11.4,   16.7,  -28.8,  -11.3,   -3.9,  -23.0,    2.7, &!  2012
     		-12.9,    1.3,   -3.9,    8.6,   -2.9,   -2.9,   -8.1, &!  2012
     		 -2.1,   -1.4,    2.0,    0.4,   -8.9,    3.2,    4.4, &!  2012
     		  3.6,   -2.3,   -0.8,   -0.5,    0.5,    0.5,   -1.5, &!  2012
     		  1.5,   -0.7,    0.9,    1.3,    3.7,    1.4,   -0.6, &!  2012
     		 -0.3,   -0.3,   -0.1,   -0.3,   -2.1,    1.9,   -0.4, &!  2012
     		 -1.6,   -0.5,   -0.2,    0.8,    1.8,    0.5,    0.2, &!  2012
     		 -0.1,    0.6,   -0.6,    0.3,    1.4,   -0.2,    0.3, &!  2012
     		 -0.1,    0.1,   -0.8,   -0.8,   -0.3,    0.4,    0.2, &!  2012
     		 -0.1,    0.1,    0.0,   -0.5,    0.2,    0.3,    0.5, &!  2012
     		 -0.3,    0.4,    0.3,    0.1,    0.2,   -0.1,   -0.5, &!  2012
     		  0.4,    0.2,    0.4,115*0.0/  			!2012
 
!          Trap out of range date:
 
      if (date.lt.1900.0.or.date.gt.2020.0) go to 11
      if (date.gt.2015.0) write (6,960) date
  960 format (/' This version of the IGRF is intended for use up', &
             ' to 2015.0.'/' values for',f9.3,' will be computed', &
             ' but may be of reduced accuracy'/)
      if (date.ge.2010.0) go to 1
      t     = 0.2*(date - 1900.0)                                             
      ll    = t
      one   = ll
      t     = t - one
      if (date.lt.1995.0) then
       nmx   = 10
       nc    = nmx*(nmx+2)
       ll    = nc*ll
       kmx   = (nmx+1)*(nmx+2)/2
      else
       nmx   = 13
       nc    = nmx*(nmx+2)
       ll    = 0.2*(date - 1995.0)
       ll    = 120*19 + nc*ll
       kmx   = (nmx+1)*(nmx+2)/2
      endif
      tc    = 1.0 - t
      if (isv.eq.1) then
       tc = -0.2
       t = 0.2
      end if
      go to 2
!
    1 t     = date - 2010.0
      tc    = 1.0
      if (isv.eq.1) then
       t = 1.0
       tc = 0.0
      end if
      ll    = 2865
      nmx   = 13
      nc    = nmx*(nmx+2)
      kmx   = (nmx+1)*(nmx+2)/2
    2 r     = alt
      l     = 1
      m     = 1
      n     = 0
!
!     
      G(1)  = 0.
      GV(1) = 0. 
      F0 = -1.0D-5 
      do 10 k=2,kmx                                                   
      if (n.ge.m) go to 4  
      m     = 0
      n     = n + 1
    4 lm    = ll + l
      if(m == 0) F0 = F0 * REAL(N)/2.
      if(m == 0) F  = F0 / SQRT(2.0)
      nn = n+1
      mm = 1      
      
      if(m /= 0) then
        F = F / SQRT( REAL(N-M+1) / REAL(N+M) )    
        g(l+1)  = (tc*gh(lm) + t*gh(lm+nc))* F
      else   
        g(l+1)  = (tc*gh(lm) + t*gh(lm+nc))* F0
      endif  
        gv(l+1) = g(l+1)/real(nn)                                  
      if (m.eq.0) go to 9                                                  
      g(l+2)  = (tc*gh(lm+1) + t*gh(lm+nc+1))*F
      gv(l+2) = g(l+2)/real(nn)                 
    8 l     = l + 2
      go to 10
    9 l     = l + 1
   10 m     = m + 1
 
  300 CONTINUE

      RETURN
 
!          Error trap diagnostics:
   11 f     = 1.0d8
      write (6,961) date
  961 format (/' This subroutine will not work with a date of', &
             f9.3,'.  Date must be in the range 1900.0.ge.date', &
              '.le.2020.0.  On return f = 1.0d8., x = y = z = 0.')
      return
      END
 
 
      SUBROUTINE FELDG2 (IENTY,GLAT,GLON,ALT, BNRTH,BEAST,BDOWN,BABS)
!          Compute the DGRF/IGRF field components at the point GLAT,GLON,ALT.
!          COFRM must be called to establish coefficients for correct date
!          prior to calling FELDG.
!
!          IENTY is an input flag controlling the meaning and direction of the
!                remaining formal arguments:
!          IENTY = 1
!            INPUTS:
!              GLAT = Latitude of point (deg)
!              GLON = Longitude (east=+) of point (deg)
!              ALT  = Ht of point (km)
!            RETURNS:
!              BNRTH  north component of field vector (Gauss)
!              BEAST  east component of field vector  (Gauss)
!              BDOWN  downward component of field vector (Gauss)
!              BABS   magnitude of field vector (Gauss)
!
!          IENTY = 2
!            INPUTS:
!              GLAT = X coordinate (in units of earth radii 6371.2 km )
!              GLON = Y coordinate (in units of earth radii 6371.2 km )
!              ALT  = Z coordinate (in units of earth radii 6371.2 km )
!            RETURNS:
!              BNRTH = X component of field vector (Gauss)
!              BEAST = Y component of field vector (Gauss)
!              BDOWN = Z component of field vector (Gauss)
!              BABS  = Magnitude of field vector (Gauss)
!          IENTY = 3
!            INPUTS:
!              GLAT = X coordinate (in units of earth radii 6371.2 km )
!              GLON = Y coordinate (in units of earth radii 6371.2 km )
!              ALT  = Z coordinate (in units of earth radii 6371.2 km )
!            RETURNS:
!              BNRTH = Dummy variable
!              BEAST = Dummy variable
!              BDOWN = Dummy variable
!              BABS  = Magnetic potential (T.m)
!
!          INPUT from COFRM through COMMON /MAGCOF2/ NMAX,GB(144),GV(144),ICHG
!            NMAX = Maximum order of spherical harmonic coefficients used
!            GB   = Coefficients for magnetic field calculation
!            GV   = Coefficients for magnetic potential calculation
!            ICHG = Flag indicating when GB,GV have been changed
!
!          HISTORY:
!          COFRM and FELDG originated 15 Apr 83 by Vincent B. Wickwar
!          (formerly at SRI. Int., currently at Utah State).
!
!          May 94 (A.D. Richmond): Added magnetic potential calculation
!
!          Oct 95 (Barnes): Added ICHG
 
!      implicit none
      integer ichg, IENTYP, is, nmax
      integer ihmax, last, imax , m
      integer MK, I ,IH , ienty, K, IL
      integer ihm , ilm 
      REAL(kind=8) RTOD
      REAL(kind=8) DTOR
      REAL(kind=8) RE
      REAL(kind=8) REQ
!      REAL(kind=8) gb(144)
!      REAL(kind=8) gv(144)
      REAL(kind=8) XI(3)
      REAL(kind=8) H(196)
      REAL(kind=8) G(196)
      REAL(kind=8) RLAT
      REAL(kind=8) GLAT
      REAL(kind=8) GLON
      REAL(kind=8) ALT
      REAL(kind=8) CT
      REAL(kind=8) ST
      REAL(kind=8) RLON
      REAL(kind=8) CP
      REAL(kind=8) SP
      REAL(kind=8) XXX
      REAL(kind=8) YYY
      REAL(kind=8) ZZZ
      REAL(kind=8) RQ
      REAL(kind=8) F
      REAL(kind=8) X , Y , Z
      REAL(kind=8) S , T
      REAL(kind=8) BXXX , BYYY , BZZZ
      REAL(kind=8) BABS
      REAL(kind=8) BEAST
      REAL(kind=8) BRHO
      REAL(kind=8) BNRTH
      REAL(kind=8) BDOWN

      PARAMETER (RTOD=57.2957795130823, DTOR=0.01745329251994330, &
                 RE=6371.2, REQ=6378.160)
      
      integer ncoef
      parameter (ncoef = 196)
      COMMON /MAGCOF2/GB(ncoef),GV(ncoef),ICHG,NMAX
      SAVE IENTYP, G
      DATA IENTYP/-10000/
 
      IF (IENTY .EQ. 1) THEN
        IS=1
        RLAT = GLAT*DTOR
        CT   = SIN(RLAT)
        ST   = COS(RLAT)
        RLON = GLON*DTOR
        CP   = COS(RLON)
        SP   = SIN(RLON)
        CALL GD2CART2 (GLAT,GLON,ALT,XXX,YYY,ZZZ)
        XXX = XXX/RE
        YYY = YYY/RE
        ZZZ = ZZZ/RE
      ELSE
        IS   = 2
        XXX  = GLAT
        YYY  = GLON
        ZZZ  = ALT
      ENDIF
      RQ    = 1./(XXX**2+YYY**2+ZZZ**2)
      XI(1) = XXX*RQ
      XI(2) = YYY*RQ
      XI(3) = ZZZ*RQ
      IHMAX = NMAX*NMAX+1
      LAST  = IHMAX+NMAX+NMAX
      IMAX  = NMAX+NMAX-1
 
      IF (IENTY .NE. IENTYP .OR. ICHG .EQ. 1) THEN
        IENTYP = IENTY
	ICHG = 0
        IF (IENTY .NE. 3) THEN
	  DO 10 I=1,LAST
   10     G(I) = GB(I)
        ELSE
	  DO 20 I=1,LAST
   20     G(I) = GV(I)
        ENDIF
      ENDIF
 
      DO 30 I=IHMAX,LAST
   30 H(I) = G(I)

      MK = 3
      IF (IMAX .EQ. 1) MK=1

      DO 100 K=1,MK,2
      I  = IMAX
      IH = IHMAX

   60 IL = IH-I
      F = 2./FLOAT(I-K+2)
      X = XI(1)*F
      Y = XI(2)*F
      Z = XI(3)*(F+F)

      I = I-2
      IF (I .LT. 1) GO TO 90
      IF (I .EQ. 1) GO TO 80

      DO 70 M=3,I,2
      IHM = IH+M
      ILM = IL+M
      H(ILM+1) = G(ILM+1)+ Z*H(IHM+1) + X*(H(IHM+3)-H(IHM-1)) &
                                              -Y*(H(IHM+2)+H(IHM-2))
   70 H(ILM)   = G(ILM)  + Z*H(IHM)   + X*(H(IHM+2)-H(IHM-2)) &
                                              +Y*(H(IHM+3)+H(IHM-1))

   80 H(IL+2) = G(IL+2) + Z*H(IH+2) + X*H(IH+4) - Y*(H(IH+3)+H(IH))
      H(IL+1) = G(IL+1) + Z*H(IH+1) + Y*H(IH+4) + X*(H(IH+3)-H(IH))

   90 H(IL)   = G(IL)   + Z*H(IH)   + 2.*(X*H(IH+1)+Y*H(IH+2))
      IH = IL
      IF (I .GE. K) GO TO 60
  100 CONTINUE
 
      S = .5*H(1)+2.*(H(2)*XI(3)+H(3)*XI(1)+H(4)*XI(2))
      T = (RQ+RQ)*SQRT(RQ)
      BXXX = T*(H(3)-S*XXX)
      BYYY = T*(H(4)-S*YYY)
      BZZZ = T*(H(2)-S*ZZZ)
      BABS = SQRT(BXXX**2+BYYY**2+BZZZ**2)
      IF (IS .EQ. 1) THEN            ! (convert back to geodetic)
        BEAST = BYYY*CP-BXXX*SP
        BRHO  = BYYY*SP+BXXX*CP
        BNRTH =  BZZZ*ST-BRHO*CT
        BDOWN = -BZZZ*CT-BRHO*ST
      ELSEIF (IS .EQ. 2) THEN        ! (leave in earth centered cartesian)
        BNRTH = BXXX
        BEAST = BYYY
        BDOWN = BZZZ
      ENDIF
 
!          Magnetic potential computation makes use of the fact that the
!          calculation of V is identical to that for r*Br, if coefficients
!          in the latter calculation have been divided by (n+1) (coefficients
!          GV).  Factor .1 converts km to m and gauss to tesla.
      IF (IENTY.EQ.3) BABS = (BXXX*XXX + BYYY*YYY + BZZZ*ZZZ)*RE*.1
 
      RETURN
      END
 
      SUBROUTINE GD2CART2 (GDLAT,GLON,ALT,X,Y,Z)
!          Convert geodetic to cartesian coordinates by calling CONVRT
!          940503 A. D. Richmond

      implicit none
      REAL(kind=8) dtor
      REAL(kind=8) GDLAT,GLON,ALT,RHO,Z
      REAL(kind=8) ANG,X,Y
      PARAMETER (DTOR=0.01745329251994330)

      CALL CONVRT2 (1,GDLAT,ALT,RHO,Z)

      ANG = GLON*DTOR
      X = RHO*COS(ANG)
      Y = RHO*SIN(ANG)

      RETURN
      END
 
      SUBROUTINE CONVRT2 (I,GDLAT,ALT,X1,X2)
!          Convert space point from geodetic to geocentric or vice versa.
!
!          I is an input flag controlling the meaning and direction of the
!            remaining formal arguments:
!
!          I = 1  (convert from geodetic to cylindrical)
!            INPUTS:
!              GDLAT = Geodetic latitude (deg)
!              ALT   = Altitude above reference ellipsoid (km)
!            RETURNS:
!              X1    = Distance from Earth's rotation axis (km)
!              X2    = Distance above (north of) Earth's equatorial plane (km)
!
!          I = 2  (convert from geodetic to geocentric spherical)
!            INPUTS:
!              GDLAT = Geodetic latitude (deg)
!              ALT   = Altitude above reference ellipsoid (km)
!            RETURNS:
!              X1    = Geocentric latitude (deg)
!              X2    = Geocentric distance (km)
!
!          I = 3  (convert from cylindrical to geodetic)
!            INPUTS:
!              X1    = Distance from Earth's rotation axis (km)
!              X2    = Distance from Earth's equatorial plane (km)
!            RETURNS:
!              GDLAT = Geodetic latitude (deg)
!              ALT   = Altitude above reference ellipsoid (km)
!
!          I = 4  (convert from geocentric spherical to geodetic)
!            INPUTS:
!              X1    = Geocentric latitude (deg)
!              X2    = Geocentric distance (km)
!            RETURNS:
!              GDLAT = Geodetic latitude (deg)
!              ALT   = Altitude above reference ellipsoid (km)
!
!
!          HISTORY:
!          940503 (A. D. Richmond):  Based on a routine originally written
!          by V. B. Wickwar.
!
!          REFERENCE:  ASTRON. J. VOL. 66, p. 15-16, 1961.

      implicit none
 
      integer I

      REAL(kind=8) rtod
      REAL(kind=8) dtor
      REAL(kind=8) RE
      REAL(kind=8) REQ
      REAL(kind=8) FLTNVRS
      REAL(kind=8) E2,E4,E6,E8
      REAL(kind=8) OME2REQ
      REAL(kind=8) A21,A22,A23,A41,A42,A43,A44
      REAL(kind=8) A61,A62,A63,A81,A82,A83,A84
      REAL(kind=8) SINLAT
      REAL(kind=8) COSLAT
      REAL(kind=8) D
      REAL(kind=8) Z
      REAL(kind=8) RHO
      REAL(kind=8) X1
      REAL(kind=8) X2
      REAL(kind=8) RKM
      REAL(kind=8) SCL
      REAL(kind=8) GCLAT
      REAL(kind=8) RI
      REAL(kind=8) A2
      REAL(kind=8) A4
      REAL(kind=8) A6
      REAL(kind=8) A8
      REAL(kind=8) CCL
      REAL(kind=8) S2CL
      REAL(kind=8) C2CL
      REAL(kind=8) S4CL
      REAL(kind=8) C4CL
      REAL(kind=8) S8CL
      REAL(kind=8) S6CL
      REAL(kind=8) DLTCL
      REAL(kind=8) GDLAT
      REAL(kind=8) SGL
      REAL(kind=8) ALT


      PARAMETER (RTOD=57.2957795130823, DTOR=0.01745329251994330 , &
        RE=6371.2 , REQ=6378.160 , FLTNVRS=298.25 , &
        E2=(2.-1./FLTNVRS)/FLTNVRS , E4=E2*E2 , E6=E4*E2 , E8=E4*E4 , &
        OME2REQ = (1.-E2)*REQ , &
           A21 =     (512.*E2 + 128.*E4 + 60.*E6 + 35.*E8)/1024. , &
           A22 =     (                        E6 +     E8)/  32. , &
           A23 = -3.*(                     4.*E6 +  3.*E8)/ 256. , &
           A41 =    -(           64.*E4 + 48.*E6 + 35.*E8)/1024. , &
           A42 =     (            4.*E4 +  2.*E6 +     E8)/  16. , &
           A43 =                                   15.*E8 / 256. , &
           A44 =                                      -E8 /  16. , &
           A61 =  3.*(                     4.*E6 +  5.*E8)/1024. , &
           A62 = -3.*(                        E6 +     E8)/  32. , &
           A63 = 35.*(                     4.*E6 +  3.*E8)/ 768. , &
           A81 =                                   -5.*E8 /2048. , &
           A82 =                                   64.*E8 /2048. , &
           A83 =                                 -252.*E8 /2048. , &
           A84 =                                  320.*E8 /2048. )
!          E2 = Square of eccentricity
 
      IF (I .GE. 3) GO TO 300
 
!          Geodetic to geocentric
 
!          Compute RHO,Z
      SINLAT = SIN(GDLAT*DTOR)
      COSLAT = SQRT(1.-SINLAT*SINLAT)
      D      = SQRT(1.-E2*SINLAT*SINLAT)
      Z      = (ALT+OME2REQ/D)*SINLAT
      RHO    = (ALT+REQ/D)*COSLAT
      X1 = RHO
      X2 = Z
      IF (I .EQ. 1) RETURN
 
!          Compute GCLAT,RKM
      RKM   = SQRT(Z*Z + RHO*RHO)
      GCLAT = RTOD*ATAN2(Z,RHO)
      X1 = GCLAT
      X2 = RKM
      RETURN
 
!          Geocentric to geodetic
  300 IF (I .EQ. 3) THEN
         RHO = X1
         Z = X2
         RKM = SQRT(Z*Z+RHO*RHO)
         SCL = Z/RKM
         GCLAT = ASIN(SCL)*RTOD
      ELSEIF (I .EQ. 4) THEN
         GCLAT = X1
         RKM = X2
         SCL = SIN(GCLAT*DTOR)
      ELSE
         RETURN
      ENDIF
 
      RI = REQ/RKM
      A2 = RI*(A21+RI*(A22+RI* A23))
      A4 = RI*(A41+RI*(A42+RI*(A43+RI*A44)))
      A6 = RI*(A61+RI*(A62+RI* A63))
      A8 = RI*(A81+RI*(A82+RI*(A83+RI*A84)))
      CCL = SQRT(1.-SCL*SCL)
      S2CL = 2.*SCL*CCL
      C2CL = 2.*CCL*CCL-1.
      S4CL = 2.*S2CL*C2CL
      C4CL = 2.*C2CL*C2CL-1.
      S8CL = 2.*S4CL*C4CL
      S6CL = S2CL*C4CL+C2CL*S4CL
      DLTCL = S2CL*A2+S4CL*A4+S6CL*A6+S8CL*A8
      GDLAT = DLTCL*RTOD+GCLAT
      SGL = SIN(GDLAT*DTOR)
      ALT = RKM*COS(DLTCL)-REQ*SQRT(1.-E2*SGL*SGL)
      RETURN
      END
