! am 3/20/06 copied from /net/suncat/e/maute/plasmasphere/ctip_apex/src_coup
!   interface.F and renamed file since this is the interface from GIP
!   to the coupled dynamo
!
!-----------------------------------------------------------------------
      subroutine set_interface(
     &            dynamo_sigma_phph_dsi,dynamo_sigma_lmlm_msi,
     &            dynamo_sigma_h,dynamo_sigma_c,
     &            dynamo_Kdmph_dsi,dynamo_Kdmlm,dim1,dim2)

      use dynamo_gip_module,only:
     |  zigm11,   ! zigm11 is int[sig_p*d_1^2/D] ds,   i.e. Sigma_(phi phi)/abs(sin Im)
     |  zigm22,   ! zigm22 is int[sig_p*d_2^2/D] ds,   i.e. Sigma_(lam lam)*abs(sin Im)
     |  zigmc,    ! zigmc  is int[sig_p*d_1*d_2/D] ds, i.e. Sigma_c
     |  zigm2,    ! zigm2  is int[sigma_h] ds,	       i.e. Sigma_h
     |  rim       ! K_(m phi)^D/abs(sin Im),  K_(m lam)^D
     
      use params_module,only:
     |  nmlonp1,! nmlon+1
     |  nmlat   ! number of geomagnetic grid latitudes
      
      implicit none 
      integer, intent(in) ::dim1,dim2
      real, intent(in) :: 
     |    dynamo_sigma_phph_dsi(dim1,dim2),
     |    dynamo_sigma_lmlm_msi(dim1,dim2),
     |    dynamo_sigma_h(dim1,dim2),dynamo_sigma_c(dim1,dim2),
     |    dynamo_Kdmph_dsi(dim1,dim2),dynamo_Kdmlm(dim1,dim2)
     
      integer :: i,j
      
!     
!cghgm comment these out....
      zigm11    = dynamo_sigma_phph_dsi	! zigm11 is int[sig_p*d_1^2/D] ds,   i.e. Sigma_(phi phi)/abs(sin Im)
      zigm22    = dynamo_sigma_lmlm_msi	! zigm22 is int[sig_p*d_2^2/D] ds,   i.e. Sigma_(lam lam)*abs(sin Im)
      zigmc     = dynamo_sigma_c 	! zigmc  is int[sig_p*d_1*d_2/D] ds, i.e. Sigma_c
      zigm2     = dynamo_sigma_h	! zigm2  is int[sigma_h] ds,	     i.e. Sigma_h
      rim(:,:,1)= dynamo_Kdmph_dsi	! K_(m phi)^D/abs(sin Im)
      rim(:,:,2)= dynamo_Kdmlm	        ! K_(m lam)^D
! cghgm - try this fix..... 
!zigm11 = 0.01
!zigm22 = 0.01
!zigmc = 0.01
!zigm2 = 0.01
!       rim = 0
!cghgm .. end of the fix ..
!      do i = 1,nmlonp1
!        write(103,90006) (zigm11(i,j),j=1,20)
!      enddo
!90006 format (10e12.4)
!	
! am 10/04 change sign of K_(m lam)^D in the SH- that's what TIEGCM dynamo
! expects
!      do j = 1,(nmlat+1)/2
!        rim(:,j,2) = -rim(:,j,2)
!      enddo
!      rim(:,:,2) = -rim(:,:,2)  ! am 8/15/08 apperently an error
!      
! am 10/04 set high latitude values since these are no calculated
! in the plasmasphere model region of Heelis pattern
! value itself should not matter since potential is prescribed      
      do j = 1,14
	zigm11(:,j) = 0.01
	zigm22(:,j) = 0.01
	zigm11(:,nmlat+1-j) = 0.01
	zigm22(:,nmlat+1-j) = 0.01
! test to fix high value at 0 and 180 deg longitude ??? am 11/13/07
!        rim(:,nmlat+1-j,2) = 0
!        rim(:,j,2)         = 0
      enddo
!      
! am 10/04 so far no value at the equator therefore set it
! but this shouldn't be in the code
      j = nmlat/2+1
      do i = 1,nmlonp1
	zigm11(i,j)= .125*(zigm11(i,j-1)+ zigm11(i,j+1))
	zigm22(i,j)= .125*(zigm22(i,j-1)+ zigm22(i,j+1))
	zigmc(i,j) = .125*(zigmc(i,j-1) + zigmc(i,j+1))
	zigm2(i,j) = .06 *(zigm2(i,j-1) + zigm2(i,j+1))
	rim(i,j,1) = .06 *(rim(i,j-1,1) + rim(i,j+1,1))
	rim(i,j,2) = .06 *(rim(i,j-1,2) + rim(i,j+1,2))
      enddo ! i = 1,nmlon
!      
!      
!      call addfsech_ij('GIP2_ZIGM11','GIP2_ZIGM11',' ',zigm11,1,
!     | nmlonp1,1,nmlat)
!      call addfsech_ij('GIP2_ZIGMC' ,'GIP2_ZIGMC',' ',zigmc ,1,
!     | nmlonp1,1,nmlat)
!      call addfsech_ij('GIP2_ZIGM2' ,'GIP2_ZIGM2',' ',zigm2 ,1,
!     | nmlonp1,1,nmlat)
!      call addfsech_ij('GIP2_ZIGM22','GIP2_ZIGM22',' ',zigm22,1,
!     | nmlonp1,1,nmlat)
!      call addfsech_ij('GIP2_RIM1'  ,'GIP2_RIM1',' ',rim(:,:,1),1,
!     | nmlonp1,1,nmlat)
!      call addfsech_ij('GIP2_RIM2'  ,'GIP2_RIM2',' ',rim(:,:,2),1,
!     | nmlonp1,1,nmlat)
!     
!      
      end subroutine set_interface
