
!-----------------------------------------------------------------------
      subroutine oplus_gip(o2,o1,ne,xnmbar,xiop2p,xiop2d,
     |  lev0,lev1,lon0,lon1,lat0,lat1)
! 
      use cons_module,only: rmassinv_o2,rmassinv_o1,
     |  rmassinv_n2
      use qrj_module,only: 
     |  qop2p, ! O+(2p) ionization from qrj, used in xiop2p
     |  qop2d  ! O+(2d) ionization from qrj, used in xiop2d
      use chemrates_module,only: ! needed chemical reaction rates
     |  rk16,rk17,rk18,rk19,rk20,
     |  rk21,rk22,rk23,rk24,rk25,rk26,rk27
!      
      implicit none
!       
      integer,intent(in) :: 
     |  lev0,lev1, ! first,last pressure  indices for current task (bot->top)
     |  lon0,lon1, ! first,last longitude indices for current task (W->E)
     |  lat0,lat1  ! first,last latitude  indices for current task (S->N)
     
      real,dimension(lev0:lev1,lon0-2:lon1+2,lat0-2:lat1+2),
     |  intent(in) ::
     |  o2, o1,     ! o2, o mass mixing ratios
     |  ne,         ! electron density
     |  xnmbar      ! p0*e(-z)*barm/kT density
     
      real,dimension(lev0:lev1,lon0-2:lon1+2,lat0-2:lat1+2),
     |  intent(out) ::
     |  xiop2p,xiop2d
    
! local     
      integer :: i,k,lat,j0,nlevs
      real,dimension(lev0:lev1,lon0:lon1) :: 
     |  psi_n2      ! n2 mass mixing ratio (1-o2-o)
     
      nlevs = lev1-lev0+1
!      
! Sources and sinks (xiop2p and xiop2d are outputs):
!
      do lat=lat0,lat1
        j0  = lat
        do i=lon0,lon1
          do k=lev0,lev1-1
!
            psi_n2(k,i) = 1.-o2(k,i,j0)-o1(k,i,j0) ! n2 mixing ratio
!
            xiop2p(k,i,lat) = 
     |        0.5*(qop2p(k,i,lat)+qop2p(k+1,i,lat))/((xnmbar(k,i,lat)*
     |        ((rk16+rk17)*psi_n2(k,i)*rmassinv_n2+
     |        rk18*o1(k,i,j0)*rmassinv_o1))+(rk19(k,i,lat)+rk20
     |          (k,i,lat))*ne(k,i,j0)+rk21+rk22)
! 
            xiop2d(k,i,lat) = 
     |        (0.5*(qop2d(k,i,lat)+qop2d(k+1,i,lat))+(rk20(k,i,lat)*
     |        ne(k,i,j0)+rk22)*xiop2p(k,i,lat))/((xnmbar(k,i,lat)*
     |        (rk23*psi_n2(k,i)*rmassinv_n2+rk24*
     |        o1(k,i,j0)*rmassinv_o1+rk26*o2(k,i,j0)*rmassinv_o2))+
     |        rk25(k,i,lat)*ne(k,i,j0)+rk27)
        
          enddo ! k=lev0,lev1-1
        enddo ! i=lon0,lon1
     
      enddo ! lat=lat0,lat1
      
      end subroutine oplus_gip
!-----------------------------------------------------------------------
