      module tgcm2gip_module
      
      use params_module,only: nlon,nlat,nlev,nmlon,nmlonp1,nmlat,nlonp4,
     |  nlevp1
      use input_module,only: gip_use
      
      implicit none
!      
!      logical :: use_gip = .true. ! am 2/4/09 moved to namelist read
      CHARACTER(10) :: thermospheric_model_name
      parameter(thermospheric_model_name = 'TGCM')
!
      logical :: GIP_switches(20) 
      
! controll feedback of parameters from GIP to TGCM:
      logical, parameter :: MolecIon_feedback = .true.
      logical, parameter :: Oplus_feedback    = .true.
      logical, parameter :: dynamo_feedback   = .true.
!     logical, parameter :: dynamo_feedback   = .false.
!     logical, parameter :: MolecIon_feedback = .false.
!     logical, parameter :: dynamo_feedback   = .false.  
      
! for start-up file  (this can go into the namelist read later)   
      character(len=100) :: GIP_input_dataset 
      character(len=100) :: GIP_output_dataset 
     
      character(len=100),parameter :: gip_static_file_location = 
     |  '$TGCMDATA/gip/static_files/'
!      character(len=100),parameter ::  GIP_Apex_coords_static_file = 
!     |  '$TGCMDATA/gip/static_files/GIP_coords.13813.31hts.format'
      character(len=100),parameter ::  GIP_Apex_coords_static_file = 
     |  '$TGCMDATA/gip/static_files/GIP_COORDS_FILE'
!     character(len=100),parameter ::  GIP_Apex_coords_static_file = 
!    |'/ptmp/ghm/gip_tiegcm_2009_astrid/tiegcm/src/GIP.13813.31hts'
      character(len=100) :: Plot_data_file  
      character(len=100) :: Profile_data_file  
      
      logical,parameter :: 
     |     sw_GIP_input_dataset_is_binary= .TRUE., 
     |     sw_GIP_output_dataset_is_binary= .TRUE.,
     |     sw_GIP_input_dataset_is_netcdf = .TRUE., 
     |     sw_GIP_output_dataset_is_netcdf = .TRUE.,
     |     sw_static_mag_field_datasets_are_binary=.FALSE. ,
     |     sw_External_model_provides_hyd_density= .FALSE.,
     |     sw_External_model_provides_NO_N4S_densities= .FALSE.,

     |     sw_External_model_provides_low_lat_E_fields= .TRUE.,

     |     sw_input_Auroral_production_is_single_overall_rate= .FALSE.,

     |     sw_reset_GIP_ion_densities_on_startup= .FALSE.
!    |     sw_reset_GIP_ion_densities_on_startup= .TRUE.

      integer :: idump_gip,jjj , istop2
      
      logical :: call_gip  ! gip is called only every 5th timestep
      
! z at t_n      
      real, dimension(nlevp1,nlon,nlat) :: z_gip_tn
!     
! fields go into GIP all on midpoints  
      real, dimension(nlev,nlon,nlat) :: tiegcm_o,tiegcm_o2,
     |  tiegcm_n2,tiegcm_tn,tiegcm_un,tiegcm_vn,tiegcm_z,
     |  tiegcm_total_aurora,
     |  tiegcm_qo2p_aurora,tiegcm_qop_aurora,tiegcm_qn2p_aurora,   ! ionization rates [1/m^3/s]
     |  tiegcm_qnp_aurora,tiegcm_qtef_aurora,                      ! ionization rates [1/m^3/s]
     |  tiegcm_elx, tiegcm_ely,      ! electric field geog. grid in geogr. direction
     |  tiegcm_vertVel, tiegcm_qion3d,     ! not used now
     |  therm_model_HYD_density_m3,	   ! dummy therm_model_HYD_density_m3,
     |  therm_model_HEL_density_m3,	   ! dummy therm_model_HEL_density_m3,
     |  therm_model_NO_density_m3,	   ! dummy therm_model_NO_density_m3,
     |  therm_model_N4S_density_m3,	   ! dummy therm_model_N4S_density_m3,
     |  therm_model_N2D_density_m3,	   ! dummy therm_model_N2D_density_m3,
     |  Te_on_therm_grid_K,        	   ! dummy
     |  Ti_Oplus_on_therm_grid_K,  	   ! dummy
     |  Ti_Hplus_on_therm_grid_K,   	   ! dummy
     |  tiegcm_dum1 , tiegcm_dum2 , tiegcm_dum3 ! dummy
     
      real,dimension(nmlonp1,nmlat) :: tgcm_ed1,tgcm_ed2
!     
      real :: tiegcm_glon(nlon),tiegcm_glat(nlat)
     
! fields come out of GIP ionosphere      
      real, dimension(nlev,nlon,nlat) :: 
     |    gip_Ne_density,gip_oplus_density,		! output
     |    gip_hplus_density,gip_noplus_density,  	! output
     |    gip_o2plus_density, gip_n2plus_density,       ! output
     |    gip_nplus_density
! fields come out of GIP dynamo   
      real, dimension(nmlonp1,nmlat) :: 
     |    gip_dynamo_sigma_phph_dsi,gip_dynamo_sigma_lmlm_msi,! output dynamo
     |    gip_dynamo_sigma_h,gip_dynamo_sigma_c,              ! output dynamo
     |    gip_dynamo_Kdmph_dsi,gip_dynamo_Kdmlm               ! output dynamo

! peak parameters from gip
      REAL(kind=8) :: ne_high_res_fixed(31,91,90)

!     
! save values for the next timestep if GIP is not updating the values     
      real, dimension(nlevp1,nlonp4,nlat) ::   ne_set_itc,ne_set_itp, 
     |     op_set_itc,op_set_itp,op_nm_set_itc,op_nm_set_itp,
     |     n2p_set,o2p_set_itc,o2p_set_itp,nop_set,nplus_set  
!
      contains
!-----------------------------------------------------------------------
      subroutine interface_gip
!
! am 3/10/06
! Lei 9/20/06 change cm to m unit;
! interface to GIP model
! all fields are on midpoints
! the format is:
!   geog.long [deg]
!   geog.lat [deg]
!   O1 in [1/m^3]
!   O2 in [1/m^3]
!   N2 in [1/m^3]
!   TN in [K]
!   UN in [m/s]: east
!   VN in [m/s]: south
!   Z in  [m]
!   W+dp/dt in  [m/s]
!   EX in [V/m] on geogr. grid in geogr. eastward direction in GIP EX southward
!   EY in [V/m] on geogr. grid in geogr. northward direction in GIP EY eastward 
! Note that for the temperature to calculate the density we use the
!   NOT updated TN (itp) which is also used in subroutine comp
! Note it works only serial (GIP is serial too)
!                                                                                
      
      use fields_module,only: tn,un,vn,o1,o2,z,itc,itp,barm,w  ! at subdomains  
      use efield_module,only: ex,ey     ! at subdomains 
      use cons_module,only: ylatg,ylong,pi,rmassinv_o2,rmassinv_o1,
     |  rmassinv_n2,p0,expz,boltz,dt,
     |  grav,   ! acceler. due to gravity at lower boundary [cm/s^2]
     |  gask    ! gas konstant 8.314e7 [ergs/K/mol]
      use mpi_module,only: lon0,lon1,lat0,lat1
! local
      integer :: i,lat,k
      integer, parameter:: unit_gip=99
      real :: z_half(1:nlev),xnmbar,xn2,z_half_tn(1:nlev)
      real,dimension(1:nlev,1:lon1+2,1:nlat):: o2_cm3,o1_cm3,n2_cm3,
     | dum1_cm3,dum2_cm3,dum3_cm3 ! dummy
      
! longitude     
      tiegcm_glon(1:nlon) = ylong(1:nlon)*180./pi
	
! latitude     
      tiegcm_glat(1:nlat) = ylatg(1:nlat)*180./pi
	                                                                 
! O1 in [1/cm^3]
! O2 in [1/cm^3]
! N2 in [1/cm^3]

! Major species number densities [1/cm^3]:
! mass density [g/cm^3/mol]: xnmbar half levels
! pressure at half level: p0*expz(k) [dyn/cm^2]
! mean molecular weight at full level: barm [g/mol]
! Boltzmann constant [erg/K]
! neutral temperature [K]: use itp value not updated one to be
!                          consistent with code
! mass mixing rations[-]: o2, o1, xn2
! inverse of mean molecular weight [mol/g]:rmassinv_o2, rmassinv_o1, rmassinv_n2
!
      do lat = 1,nlat
        do i=lon0,lon1-2
          do k=1,nlev
            xnmbar = p0*expz(k)*.5*(barm(k,i,lat,itp)+
     |        barm(k+1,i,lat,itp))/(boltz*tn(k,i,lat,itp))
            o2_cm3(k,i,lat) = o2(k,i,lat,itp)*xnmbar*rmassinv_o2
            o1_cm3(k,i,lat) = o1(k,i,lat,itp)*xnmbar*rmassinv_o1
            xn2 = (1.-o2(k,i,lat,itp)-o1(k,i,lat,itp))
            xn2 = xn2*rmassinv_n2	       ! this part varies from timegcm
            if (xn2 < 1.e-20) xn2 = 1.e-20   ! done as in tiegcm
            n2_cm3(k,i,lat) = xn2*xnmbar
!	    
	    tiegcm_o(k,i-2,lat) = o1_cm3(k,i,lat)*1e6
	    tiegcm_o2(k,i-2,lat)= o2_cm3(k,i,lat)*1e6
	    tiegcm_n2(k,i-2,lat)= n2_cm3(k,i,lat)*1e6
	    
	    tiegcm_dum1(k,i-2,lat) = 0.  ! dummy
	    tiegcm_dum2(k,i-2,lat)= 0 
	    tiegcm_dum3(k,i-2,lat)= 0 
          enddo ! k=lev0,lev1-1
         enddo ! i=lon0,lon1                   
      enddo ! lat = 1,nlat

       do lat=1,nlat
        do i = lon0,lon1-2
	  do k = 1,nlev
	    tiegcm_tn(k,i-2,lat) = tn(k,i,lat,itp)
	    tiegcm_un(k,i-2,lat) = un(k,i,lat,itp)/100.
	    tiegcm_vn(k,i-2,lat) = -vn(k,i,lat,itp)/100.
            z_half(k)= 0.5*(z(k,i,lat,itc)+z(k+1,i,lat,itc))/100.    ! Z to half level - k'
	    tiegcm_z(k,i-2,lat) = z_half(k)
	    
! scale height H [cm] to convert omega [1/s] to vertical neutral wind [cm/s]
! w updated t_n+1 itc, but take value from t_n
! barm is updated, but value for t_n+1 is in itp
! Tn is updated, use itp value
! 
            tiegcm_vertVel(k,i-2,lat) = 0.5*(w(k,i,lat,itp)+
     |        w(k+1,i,lat,itp))*gask*tn(k,i,lat,itp)/
     |        (.5*(barm(k,i,lat,itp)+barm(k+1,i,lat,itp))*grav) ![cm/s]
! 
! add dz/dt (positiv upward)
            z_half_tn(k)=0.5*(z_gip_tn(k,i-2,lat)+z_gip_tn(k+1,i-2,lat))
	    tiegcm_vertVel(k,i-2,lat) = tiegcm_vertVel(k,i-2,lat)/100. + 
     |           (z_half(k)-z_half_tn(k)/100.)/dt        ! [m/s]
!     
! electric field converted from [V/cm] to [V/m] and to midpoint level  & convert to GIP convention s above   
            tiegcm_elx(k,i-2,lat) = -0.5*(ey(k,i,lat)+ey(k+1,i,lat))*100. !  to half level - k'
            tiegcm_ely(k,i-2,lat) =  0.5*(ex(k,i,lat)+ex(k+1,i,lat))*100.
            
	  enddo
        enddo
      enddo
      
      end subroutine interface_gip
!------------------------------------------------------------------------------
      subroutine interface_tgcm
!
!  copy the O+ from GIP [#/m^3] to TGCM O+ [#/cm^3] at half levels
!
      use fields_module,only: op,op_nm,itc,itp,ne,nplus,n2p,nop,o2p
      use cons_module,only: kut,dtsmooth,dtsmooth_div2
      use mpi_module,only: lon0,lon1,lat0,lat1
      use params_module,only: nlevp1,nlat
      use oplus_module,only: filter_op
!      
      integer :: i,k,lat,lev0,lev1
!      integer,parameter :: kutt_5(36) = ! for 5 degree latitude resolution
!     |  (/1,2,3,5,6,7,9,10,11,13,14,15,17,17,17,17,17,17,17,17,17,17,17,
!     |   17,15,14,13,11,10,9,7,6,5,3,2,1/)
!      integer :: kutt(nlat)
      
      lev0= 1
      lev1= nlevp1
      
      if(Oplus_feedback) then
!       write(6,*) '** Feeding back O+ ion density from GIP to TGCM **'
! 
!  copy gip_oplus_density into op(itc)
      do lat = lat0,lat1
        do i=lon0+2,lon1-2
	     op(1:nlev,i,lat,itc) = gip_oplus_density(1:nlev,i-2,lat)*1e-6  ! convert from 1/m^3 to 1/cm^3
	     op(nlevp1,i,lat,itc) = gip_oplus_density(nlev,i-2,lat)*1e-6    ! convert from 1/m^3 to 1/cm^3
        enddo ! i=lon0,lon1
	op(:,1,lat,itc)	    =  op(:,lon1-1,lat,itc)
	op(:,2,lat,itc)	    =  op(:,lon1  ,lat,itc)
	op(:,lon1-1,lat,itc)=  op(:,lon0+2,lat,itc)	    
	op(:,lon1  ,lat,itc)=  op(:,lon0+3,lat,itc)
!        call addfsech('OP_1','OP_1','#/cm^3',
!     |    	op(:,lon0:lon1,lat,itc),lon0,lon1,nlevp1,nlev,lat)      
!	    
      enddo ! lat = 1,nlat
      
! Set kut for wave filtering according to dlat (2.5 or 5.0 degrees):
!      call set_wave_filter(36,kutt_5,nlat,kutt)
!
! Filter updated O+:
! 
      call filter_op(op(:,lon0:lon1,lat0:lat1,itc),
     |  1,nlevp1,lon0,lon1,lat0,lat1,kut)
! 
! Time smoothing:
!
! op(k,i,lat,itc)   : New O+ at t_n+1 -> GIP O+
! op_nm(k,i,lat,itc): New O+ at t_n
! op(k,i,lat,itp)      : O+ at t_n
! op_nm(k,i,lat,itp)   : O+ at t_n-1.
!
      do lat = 1,nlat
!        call addfsech('OP_2','OP_2','#/cm^3',
!     |    	op(:,lon0:lon1,lat,itc),lon0,lon1,nlevp1,nlev,lat) 
        do i=lon0,lon1
          do k=lev0,lev1-1	
            op_nm(k,i,lat,itc) = dtsmooth*op(k,i,lat,itp)+dtsmooth_div2*
     |          (op_nm(k,i,lat,itp)+op(k,i,lat,itc))
          enddo ! k=lev0,lev1-1      
        enddo ! i=lon0,lon1	
      enddo ! lat = 1,nlat
!
! Upper boundary:
      op(lev1,:,lat,itc) = 0.
      op_nm(lev1,:,lat,itc) = 0.
!
! Insure non-negative O+:
      do lat = lat0,lat1
	do i=lon0,lon1
	  do k=lev0,lev1-1     
	    if (op(k,i,lat,itc)    < 1.e-5) op(k,i,lat,itc) = 1.e-5
	    if (op_nm(k,i,lat,itc) < 1.e-5) op_nm(k,i,lat,itc) = 1.e-5
	  enddo ! k=lev0,lev1-1      
	enddo ! i=lon0,lon1
!        call addfsech('OP_3','OP_3','#/cm^3',
!     |    	op(:,lon0:lon1,lat,itc),lon0,lon1,nlevp1,nlev,lat) 	     
      enddo ! lat = 1,nlat
      
      endif ! Oplus_feedback
      
      if(MolecIon_feedback) then
!       write(6,*) '** Feeding back Molecular ions from GIP to TGCM'
      
!  copy gip_ne_density into ne(itc)

! test for GIP
! Insure positive Ne (at least 3100):
      do lat = lat0,lat1
	do i=lon0+2,lon1-2
	  do k=lev0,lev1-1
	     if (gip_ne_density(k,i-2,lat) < 1.0e6) 
     |  	   gip_ne_density(k,i-2,lat) = 1.0e6
	  enddo 
	enddo
      
! Transfer electrons output array:
! from half level (midpoint) to full level (interface)
       do i=lon0+2,lon1-2
	 do k=lev0,lev1-2
	   ne(k+1,i,lat,itc) = sqrt(gip_ne_density(k,i-2,lat)*
     |  	  gip_ne_density(k+1,i-2,lat))*1e-6  ! convert from 1/m^3 to 1/cm^3
	 enddo ! k=lev0,lev1-2

! Lower and upper boundaries:
	 ne(lev0,i,lat,itc) = sqrt(gip_ne_density(lev0  ,i-2,lat)**3/
     |  	  gip_ne_density(lev0+1,i-2,lat))*1e-6
	 ne(lev1,i,lat,itc) = sqrt(gip_ne_density(lev1-1,i-2,lat)**3/
     |  	  gip_ne_density(lev1-2,i-2,lat))*1e-6
	enddo ! i=lon0,lon1
	ne(:,1,lat,itc)	    =  ne(:,lon1-1,lat,itc)
	ne(:,2,lat,itc)	    =  ne(:,lon1  ,lat,itc)
	ne(:,lon1-1,lat,itc)=  ne(:,lon0+2,lat,itc) 	
	ne(:,lon1  ,lat,itc)=  ne(:,lon0+3,lat,itc) 	 
      enddo ! lat = 1,nlat
      
! Calculate N2+, O2+, NO+ (cm3)
!
      do lat = lat0,lat1
        do i=lon0+2,lon1-2      
          do k=lev0,lev1-1
            n2p(k,i,lat)    = gip_n2plus_density(k,i-2,lat)*1e-6  ! convert from 1/m^3 to 1/cm^3
            o2p(k,i,lat,itc)= gip_o2plus_density(k,i-2,lat)*1e-6  ! convert from 1/m^3 to 1/cm^3
            nop(k,i,lat)    = gip_noplus_density(k,i-2,lat)*1e-6  ! convert from 1/m^3 to 1/cm^3
            nplus(k,i,lat)  = gip_nplus_density(k,i-2,lat)*1e-6   ! convert from 1/m^3 to 1/cm^3
	    
          enddo ! k=lev0,lev1-1
        enddo ! i=lon0,lon1
	o2p(:,1,lat,itc)     =  o2p(:,lon1-1,lat,itc)
	o2p(:,2,lat,itc)     =  o2p(:,lon1  ,lat,itc)
	o2p(:,lon1-1,lat,itc)=  o2p(:,lon0+2,lat,itc)     
	o2p(:,lon1  ,lat,itc)=  o2p(:,lon0+3,lat,itc)
	n2p(:,1,lat)     =  n2p(:,lon1-1,lat)
	n2p(:,2,lat)     =  n2p(:,lon1  ,lat)
	n2p(:,lon1-1,lat)=  n2p(:,lon0+2,lat)     
	n2p(:,lon1  ,lat)=  n2p(:,lon0+3,lat)       
	nop(:,1,lat)     =  nop(:,lon1-1,lat)
	nop(:,2,lat)     =  nop(:,lon1  ,lat)
	nop(:,lon1-1,lat)=  nop(:,lon0+2,lat)     
	nop(:,1,lat)     =  nop(:,lon1-1,lat)
	nplus(:,2,lat)     =  nplus(:,lon1  ,lat)
	nplus(:,lon1-1,lat)=  nplus(:,lon0+2,lat)     
	nplus(:,lon1  ,lat)=  nplus(:,lon0+3,lat)       
	nplus(:,lon1  ,lat)=  nplus(:,lon0+3,lat)       
      enddo ! lat = 1,nlat  
      
      endif ! MolecIon_feedback
!      
      end subroutine interface_tgcm
!------------------------------------------------------------------------------
      subroutine set_tgcm_values(i_call_gip,istep,i_switch)
!
      use fields_module,only: op,op_nm,itc,itp,ne,nplus,n2p,nop,o2p
      use mpi_module,only: lon0,lon1,lat0,lat1
      use params_module,only: nlevp1,nlat,nlev
!       
      integer, intent(in) :: i_call_gip,istep,i_switch
      
      integer :: j
! 
!	  write(6,*) 'set_tgcm_value ',nlevp1,nlonp4,nlat
!	  write(6,*) 'set_tgcm_value ',lon0,lon1,lat0,lat1
      if(i_switch == 0) then  ! during the timestep
! save values from gip call or first timestep     
        if(i_call_gip == 1) then
!	  write(6,*) 'set_tgcm_value: save them',
!     |         i_call_gip,istep,i_switch,itc,itp
          if(Oplus_feedback) then
            op_set_itc  = op(:,lon0:lon1,lat0:lat1,itc)
            op_set_itp  = op(:,lon0:lon1,lat0:lat1,itp)
            op_nm_set_itc= op_nm(:,lon0:lon1,lat0:lat1,itc)
            op_nm_set_itp= op_nm(:,lon0:lon1,lat0:lat1,itp)
	  endif  
          if(MolecIon_feedback) then
            ne_set_itc  = ne(:,lon0:lon1,lat0:lat1,itc)
            ne_set_itp  = ne(:,lon0:lon1,lat0:lat1,itp)
            n2p_set	= n2p(:,lon0:lon1,lat0:lat1)
            o2p_set_itc = o2p(:,lon0:lon1,lat0:lat1,itc)
            o2p_set_itp = o2p(:,lon0:lon1,lat0:lat1,itp)
            nop_set	= nop(:,lon0:lon1,lat0:lat1)
            nplus_set	= nplus(:,lon0:lon1,lat0:lat1)
	  endif  
!	  write(6,*) 'set_tgcm_value save: ne_itc,ne_itp',
!     |        ne_set_itc(10,10,10),ne_set_itp(10,10,10)
!	  do j = 1,nlat
!            call addfsech('ne_itc','ne_itc',' ',
!     |    	ne_set_itc(:,lon0:lon1,j),lon0,lon1,nlevp1,nlev,j)
!            call addfsech('ne_itp','ne_itp',' ',
!     |    	ne_set_itp(:,lon0:lon1,j),lon0,lon1,nlevp1,nlev,j)
!            call addfsech('op_itp','op_itp','',
!     |    	op_set_itp(:,lon0:lon1,j),lon0,lon1,nlevp1,nlev,j)
!            call addfsech('op_itc','op_itc',' ',
!     |    	op_set_itc(:,lon0:lon1,j),lon0,lon1,nlevp1,nlev,j)
!            call addfsech('op_nm_itp','op_nm_itp',' ',
!     |    	op_nm_set_itp(:,lon0:lon1,j),lon0,lon1,nlevp1,nlev,j)
!            call addfsech('op_nm_itc','op_nm_itc',' ',
!     |    	op_nm_set_itc(:,lon0:lon1,j),lon0,lon1,nlevp1,nlev,j)
!            call addfsech('n2p_set','n2p_set',' ',
!     |    	n2p_set(:,lon0:lon1,j),lon0,lon1,nlevp1,nlev,j)
!            call addfsech('o2p_set_itc','o2p_set_itc',' ',
!     |    	o2p_set_itc(:,lon0:lon1,j),lon0,lon1,nlevp1,nlev,j)
!            call addfsech('o2p_set_itp','o2p_set_itp',' ',
!     |    	o2p_set_itp(:,lon0:lon1,j),lon0,lon1,nlevp1,nlev,j)
!            call addfsech('nop_set','nop_set',' ',
!     |    	nop_set(:,lon0:lon1,j),lon0,lon1,nlevp1,nlev,j)
!            call addfsech('nplus_set','nplus_set',' ',
!     |    	nplus_set(:,lon0:lon1,j),lon0,lon1,nlevp1,nlev,j)
!          enddo
        endif
!      
! copy values into TGCM arrays; for first timestep already calculated in dynamics
        if(istep > 1 ) then
!	  write(6,*) 'set_tgcm_value: copy them',
!     |         i_call_gip,istep,i_switch,itc,itp
          if(Oplus_feedback) then
            op(:,lon0:lon1,lat0:lat1,itc) = op_set_itc
            op(:,lon0:lon1,lat0:lat1,itp) = op_set_itp
            op_nm(:,lon0:lon1,lat0:lat1,itc)= op_nm_set_itc
            op_nm(:,lon0:lon1,lat0:lat1,itp)= op_nm_set_itp
	  endif
          if(MolecIon_feedback) then
            ne(:,lon0:lon1,lat0:lat1,itc) = ne_set_itc
            ne(:,lon0:lon1,lat0:lat1,itp) = ne_set_itp
            n2p(:,lon0:lon1,lat0:lat1)    = n2p_set
            o2p(:,lon0:lon1,lat0:lat1,itc)= o2p_set_itc
            o2p(:,lon0:lon1,lat0:lat1,itp)= o2p_set_itp
            nop(:,lon0:lon1,lat0:lat1)    = nop_set
            nplus(:,lon0:lon1,lat0:lat1)  = nplus_set
	  endif
!	  write(6,*) 'set_tgcm_value copy: ne_itc,ne_itp',
!     |        ne(10,10,10,itc),ne(10,10,10,itp)
        endif
!       
      else  ! switch itc and itp for next timestep
!       
!       write(6,*) 'set_tgcm_value: switch them',
!     |         i_call_gip,istep,i_switch,itc,itp
        if(Oplus_feedback) then
          op(:,lon0:lon1,lat0:lat1,itc) = op_set_itp
          op(:,lon0:lon1,lat0:lat1,itp) = op_set_itc
          op_nm(:,lon0:lon1,lat0:lat1,itc)= op_nm_set_itp
          op_nm(:,lon0:lon1,lat0:lat1,itp)= op_nm_set_itc
	endif
        if(MolecIon_feedback) then
          ne(:,lon0:lon1,lat0:lat1,itc) = ne_set_itp
          ne(:,lon0:lon1,lat0:lat1,itp) = ne_set_itc
          o2p(:,lon0:lon1,lat0:lat1,itc)= o2p_set_itp
          o2p(:,lon0:lon1,lat0:lat1,itp)= o2p_set_itc
	endif
!	  write(6,*) 'set_tgcm_value switch: ne_itc,ne_itp',
!     |        ne(10,10,10,itc),ne(10,10,10,itp)
!	  write(6,*) 'set_tgcm_value switch: ne_itc,ne_itp',
!     |        ne_set_itp(10,10,10),ne_set_itc(10,10,10)
!       
      endif
!      
      end subroutine set_tgcm_values
!-----------------------------------------------------------------------
      subroutine set_efield4gip
! set electric field only for the first timestep, otherwise it comes from 
! subroutine threed in dynamo.F
!      
      use efield_module,only:emx,emy ! 3d electric field on magnetic grid.
      use fields_module,only: phim3d ! 3d electric potential on magnetic grid
      use cons_module,only: r0,dt1dts,dt0dts,nmlat

! am 1/10 phim not used
!      
      implicit none 
      integer :: j
!
! use only lowest level, assuming that the electric field
! does not vary a lot with height
      tgcm_ed1(:,:) = emx(:,:,2)/(r0*1.e-2)  
!      phim(:,:)= phim3d(:,:,2)
      do j=1,nmlat 
        tgcm_ed2(:,j) =    emy(:,j,2)*dt1dts(j)/dt0dts(j)/(r0*1.e-2)
      enddo
      
      end subroutine set_efield4gip
!------------------------------------------------------------------------------
!
      end module tgcm2gip_module
